;Fichero: ARKANO3.ASM    Modulo 3 de la prctica orientado a la escritura en
TITLE ARKANO3         ;pantalla, la lectura por encuesta sobre el teclado y a
                      ;la lectura del teclado por interrupciones.
                      
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN DIR_PANT:FAR    ;Rutina que calcula el modo de video.
EXTRN PRESENT2:FAR    ;Rutina que escribe la linea de informacin permanente.
EXTRN DIB_PALA:FAR    ;Rutina que dibuja el coche en la posicin (i,j).
EXTRN LEER_NOM:FAR    ;Rutina que realiza la encuesta sobre el teclado.
EXTRN LEECAR_E:FAR    ;Rutina que lee el cdigo de rastreo de la tecla pulsada
EXTRN LEECAR_I:FAR    ;rutina que realiza la lectura del teclado por 
                      ;interrupciones.
EXTRN RELOJINT:FAR    ;rutina de atencin a las interrupciones de reloj.
EXTRN HORAPAN:FAR     ;rutina que escribe el tiempo transcurido en la pantalla
;
PANTALLA SEGMENT AT 0B800H
         DW 80*25 DUP (?)
PANTALLA ENDS
;
PILA     SEGMENT PARA STACK 'PILA'
         DB 64 DUP ('PILA    ')
PILA     ENDS
;
PUBLIC LINEA_HORI,LINEA_VACIA,LINEA_REG1,LINEA_REG2,LINEA_REG3,LINEA_INFO
PUBLIC LIN1_PALA,LIN2_PALA,POSI_PALA,DIRPAN,FIL_PELO,COL_PELO,M,NOM,TABLA
PUBLIC FIN_JUEGO,MINUT1,MINUT2,SEGUN1,SEGUN2,TIEMPO
DATOS  SEGMENT PARA PUBLIC 'DATOS'
FIN_JUEGO   DB ?
REL_IP      DW ?             ;Variables que contienen los antiguos CS e IP
REL_CS      DW ?
TEC_IP      DW ?
TEC_CS      DW ?
NOM         DB '        '
TABLA       DB 27,'1234567890-='
            DB 8,9,'QWERTYUIOP[]',13,'*'
            DB 'ASDFGHJKL$;$','*'
            DB '<ZXCVBNM,.-','*'
            DB' ','*'
            DB ' ', 13 DUP ('*')
            DB '789-456+1230'
M DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
  DB'۲۲۲۲'
FIL_PELO    DB ?
COL_PELO    DB ?
LIN1_PALA   DB 'ͻ'
LIN2_PALA   DB 'ͼ'
POSI_PALA   DB ?
DIRPAN      DW ?
LINEA_HORI  DB '   '
            DB '   '
LINEA_VACIA DB '                                       '
            DB '                                       '
LINEA_REG1  DB '  Teclas de movimiento   :   *O* mover'  
            DB ' izquierda     *P* mover derecha  '     
LINEA_REG2  DB '  Tecla de fin del juego :   *F*      '
            DB '                                  '
LINEA_REG3  DB '  Teclee su nombre y pulse Intro : -  '
            DB '      -                           '
LINEA_INFO  DB ' Nombre:          I  Jugadas:  I  ARKANOID  I'
            DB ' Ptos:0000 I Tiempo:  :    '
MINUT1      DB 0    ;Variables que contienen
MINUT2      DB 0    ;el tiempo transcurrido
SEGUN1      DB 0    ;desde el comienzo
SEGUN2      DB 0    ;del juego.
TIEMPO      DB 0    ;variable que se incrementa a cada interrupcin del reloj.
DATOS       ENDS
;
CODIGO SEGMENT PARA PUBLIC 'CODIGO'
       ASSUME CS:CODIGO,DS:DATOS,SS:PILA
;
ARKANO3 PROC FAR
;para volver al DOS primero se empila la @ de retorno
       PUSH DS             ;se empila el seg. de datos del DOS
       SUB  AX,AX          ;AX:=0
       PUSH AX             ;se empila el desplazamiento (0)

       MOV AX,DATOS
       MOV DS,AX           ;se inicializa nuestor seg. de datos

       CALL DIR_PANT       ;Calculamos la @ de comienzo da la pantalla
       MOV ES,AX           ;Se inicializa el seg. extra ; ES:= @ pantalla
       
       CALL PRESENT1       ;Presentacion inicial del juego.
       
       CALL LEER_NOM       ;Subrutina que escribe el nombre del jugador por
                           ;pantalla y lo guarda en la variable NOM.
                           
       CALL PRESENT2       ;Escribimos la linea permanente de informacim 
                           ;sobre el estado del juego.
                           
       CALL DIB_MURO       ;Subrutina que dibuja el muro incial en pantalla.
       
       MOV  POSI_PALA,34   ;Dibujamos la pala en la posicin indicada por
       CALL DIB_PALA       ;la variable POSI_PALA.
       
       MOV  FIL_PELO,18
       MOV  COL_PELO,39    ;Dibujamos la pelota en la posicin que indican
       CALL DIB_PELO       ;las variables FIL_PELO y COL_PELO.
       
       CALL ESCR_NOM       ;Escribimos de la variable NOM el nombre 

       PUSH ES             ;guardamos la @base de la pantalla
       CALL CAMBIAR_V_I    ;cambiamos el vector de interrupciones
       POP  ES             ;en ES @base de pantalla para ESCR_CAR       
       
BUC1:  CMP  FIN_JUEGO,33   ;bucle que sirve para poder se interrunpidos
       JNZ   BUC1

       CALL RESTAURAR_V_I  ;restauramos el vector de interrupciones
       RET

ARKANO3 ENDP

;Rutina que realiza la presentacin inicial del juego.
PRESENT1 PROC NEAR
       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX
       PUSH DX
       PUSH SI
       PUSH DI             ;salvar registros

       MOV  BX,03H         ;BX:=atributo
       MOV  DI,0           ;inicializamos el contador de filas
WHILE1:CMP  DI,25
       JZ   FINAL1         ;si fila=25 => FIN1
       MOV  SI,0           ;inicializamos el contador de columnas
       
WHILE2:CMP  SI,80
       JZ   FIN2           ;si columna=80 => FIN2
       CMP  DI,0
       JZ   L_HOR          ;si fila=0 o fila= 24=> escribimos linea horizontal
       CMP  DI,24          ;sino escribimos la linea vacia
       JZ   L_HOR
       MOV  AL,DS:LINEA_VACIA[SI] ;escribimos linea vaca y continuamos
       JMP  CONTI
L_HOR: MOV  AL,DS:LINEA_HORI[SI]  ;escribimos linea horizontal y continuamos
       
CONTI: PUSH BX             ;empilamos el atributo
       PUSH AX             ;empilamos el caracter
       PUSH SI             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI             ;incremantamos la columna
       JMP  WHILE2
FIN2:  INC  DI             ;incrementamos la fila
       JMP  WHILE1
       
;escribimos reglas del juego
FINAL1:MOV  BX,0FH
       MOV  DI,12
       MOV  SI,4
WH3:   CMP  SI,76
       JZ   FIN3
       CMP  DI,12
       JZ   REG1
       CMP  DI,13
       JZ   REG2
       JMP  REG3
REG1:  MOV  AL,DS:LINEA_REG1[SI-4]  ;escribimos datos y continuamos
       JMP  EMPI
REG2:  MOV  AL,DS:LINEA_REG2[SI-4]  ;escribimos datos y continuamos
       JMP  EMPI
REG3:  MOV  AL,DS:LINEA_REG3[SI-4]  ;escribimos datos y continuamos
EMPI:  PUSH BX             ;empilamos el atributo
       PUSH AX             ;empilamos el caracter
       PUSH SI             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI        
       JMP  WH3

FIN3:  CMP  DI,14
       JZ   FINFIN
       MOV  SI,4
       INC  DI
       JMP  WH3
       
FINFIN:POP  DI
       POP  SI
       POP  CX
       POP  BX
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
PRESENT1 ENDP

;Rutina que dibuja el muro en pantalla.
DIB_MURO PROC NEAR

       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;salvar registros
       
       MOV  SI,0
       MOV  DI,0          ;inicializamos los ndices
       
COMP8: CMP  SI,8
       JGE  SIMAY
COMP73:CMP  DI,72
       JGE  DIMAY
       MOV  AX,04H
       PUSH AX             ;empilamos atributo
       
       MOV  AX,72
       MUL  SI
       ADD  AX,DI
       MOV  BX,AX
       MOV  AL,DS:M[BX]    ;AX := caracter a empilar
       
       PUSH AX             ;empilamos caracter
       MOV  AX,DI
       ADD  AX,4
       PUSH AX             ;empilamos la columna
       MOV  AX,SI
       INC  AX
       PUSH AX             ;empilamos la fila
       CALL ESCR_CAR
       INC  DI
       JMP  COMP73
       
DIMAY: MOV  DI,0
       INC  SI
       JMP  COMP8

SIMAY: POP  DI
       POP  SI
       POP  BX
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
DIB_MURO ENDP

DIB_PELO PROC NEAR   ;rutina que dibuja la pelota en la posicin (i,j).

       PUSH BP
       MOV  BP,SP             ;enlace dinmico
       PUSH AX                ;guardar registros

       MOV  AX,0FH
       PUSH AX                ;empilamos el atributo
       MOV  AL,236
       PUSH AX                ;empilamos el caracter := ''
       MOV  AL,COL_PELO
       PUSH AX                ;empilamos la columna
       MOV  AL,FIL_PELO
       PUSH AX                ;empilamos la fila
       CALL ESCR_CAR          ;llamada a subrutina de escritura
       
       POP  AX                ;restaurar registros
       POP  BP                ;restauramos emlace dinmico
       RET       
DIB_PELO  ENDP

ESCR_NOM PROC NEAR         ;Subrutina que escribe de la variable NOM, el
       PUSH BP             ;nombre del jugador tecleado.
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH SI
       PUSH DI             ;salvar registros

       MOV  DI,23
       MOV  SI,0
WHNOM: CMP  SI,8
       JZ   FINOM          ;si SI=80 => FINOM
       MOV  AX,0CH
       PUSH AX             ;empilamos el atributo
       MOV  AL,DS:NOM[SI]
       PUSH AX             ;empilamos el carcter
       MOV  AX,SI
       ADD  AX,13
       PUSH AX             ;empilamos la columna
       PUSH DI             ;empilamos la fila
       CALL ESCR_CAR       ;llamada a subrutina de escritura
       INC  SI
       JMP  WHNOM

FINOM: POP  DI
       POP  SI
       POP  AX             ;restaurar registros
       POP  BP             ;restaurar enlace dinamico
       RET
ESCR_NOM ENDP

CAMBIAR_V_I PROC NEAR ;subrutina que cambia las RUT_SER del reloj y del
                      ;teclado del DOS por las nuestras (LEECAR_I y RELOJINT)
       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX             ;salvar registros

INHIB1:CLI                 ;inhibir interrupciones
       XOR  AX,AX
       MOV  ES,AX          ;ES apunta al comienzo del vector de interrupciones
       MOV  BX,1CH*4       ;BX:=@ de la IP de la rut. de aten. del reloj (8)
       MOV  AX,ES:[BX]
       MOV  DS:REL_IP,AX   ;en REL_IP el IP anterior (DOS)
       MOV  AX,OFFSET RELOJINT
       MOV  ES:[BX],AX     ;actualizamos dicha entrada con nuestra @PI
       MOV  AX,ES:[BX+2]
       MOV  DS:REL_CS,AX   ;en REL_CS el CS anterior (DOS)
       MOV  AX,SEG RELOJINT
       MOV  ES:[BX+2],AX   ;actualizamos dicha entrada con nuestra @CS

       XOR  AX,AX
       MOV  ES,AX          ;ES apunta al comienzo del vector de interrupciones
       MOV  BX,9*4         ;BX:=@ de la IP de la rut. de aten. del teclado (9)
       MOV  AX,ES:[BX]
       MOV  DS:TEC_IP,AX   ;en TEC_IP el IP anterior (DOS)
       MOV  AX,OFFSET LEECAR_I
       MOV  ES:[BX],AX     ;actualizamos dicha entrada con nuestra @PI
       MOV  AX,ES:[BX+2]
       MOV  DS:TEC_CS,AX   ;en TEC_CS el CS anterior (DOS)
       MOV  AX,SEG LEECAR_I
       MOV  ES:[BX+2],AX   ;actualizamos dicha entrada con nuestra @CS
       STI                 ;habilitar las interrupciones

       POP  BX
       POP  AX                    ;restaurar registros
       POP  BP                    ;restaurar enlace dinamico
       RET
CAMBIAR_V_I ENDP

RESTAURAR_V_I PROC NEAR
       PUSH BP
       MOV  BP,SP          ;enlace dinamico
       PUSH AX
       PUSH BX             ;salvar registros

       CLI                 ;inhibir interrupciones
       XOR  AX,AX
       MOV  ES,AX
       MOV  BX,1CH*4
       MOV  AX,REL_IP
       MOV  ES:[BX],AX
       MOV  AX,REL_CS
       MOV  ES:[BX+2],AX

       XOR  AX,AX
       MOV  ES,AX
       MOV  BX,9*4
       MOV  AX,TEC_IP
       MOV  ES:[BX],AX
       MOV  AX,TEC_CS
       MOV  ES:[BX+2],AX
       STI                 ;habilitar interrupciones

       POP  BX
       POP  AX                    ;restaurar registros
       POP  BP                    ;restaurar enlace dinamico
       RET
RESTAURAR_V_I ENDP

CODIGO ENDS
       END ARKANO3
