; Fichero: ARKANO4.ASM
; Modulo 4 de la prctica orientado a la escritura en pantalla, la lectura
; por interrupciones y por encuesta sobre el teclado y adems la gestin
; del reloj y del resto del juego.

TITLE ARKANO4

; Rutinas NEAR que utiliza ARKANO4:
; PRESENT1, PRESENT2, CAMBIAR_V_I, RESTAURAR_V_I,ESCR_NOM,MESA_FINAL
; ALEATORIO, ACTUALIZAR_PELOTA, LUGAR_PELOTA, POSICION_PELOTA, DIB_MURO. 

; Rutinas FAR que utiliza ARKANO4:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN DIR_PANT:FAR    ;Rutina que calcula el modo de video.
EXTRN DIB_PALA:FAR    ;Rutina que dibuja la raqueta en la posicin (i,j).
EXTRN LEECAR_E:FAR    ;Rutina que lee un carcter del teclado.
EXTRN LEER_NOM:FAR    ;Rutina que realiza la encuesta sobre el teclado.
EXTRN RELOJINT:FAR    ;Rutina de atencin a las interrupciones de reloj.
EXTRN LEECAR_I:FAR    ;Rutina que realiza la lectura del teclado por 
                      ;interrupciones.
EXTRN PEGA_PAR:FAR    ;Rutina que gestiona el posible choque de la pelota
                      ;con las paredes.
EXTRN PEGA_RAQ:FAR    ;Rutina que gestiona el posible choque de la pelota
                      ;con la raqueta.
EXTRN PEGA_LAD:FAR    ;Rutina que gestiona el posible choque de la pelota
                      ;con los ladrillos.


PANTALLA SEGMENT AT 0B800H
         DW 80*25 DUP (?)
PANTALLA ENDS


PILA SEGMENT PARA STACK 'PILA'
     DB 64 DUP ('PILA    ')
PILA ENDS


; Para que las variables puedan ser modificadas en otras runtinas FAR,
; las declaro como pblicas.
PUBLIC LINEA_HORI,LINEA_VACIA,LINEA_REG1,LINEA_REG2,LINEA_REG3,LINEA_INFO
PUBLIC CAR_PELO,DIRPAN,EJEC_BUCLE,NOM,TABLA,TRES,CUATRO,MENSA_CONTINUAR
PUBLIC FIL_PELO,COL_PELO,PELOTA_X,PELOTA_Y,ZONA_PANTALLA,VELOCIDAD_PEL
PUBLIC TIEMPO_PASA,FIN_JUEGO,NUM_VIDAS,NUM_LADRILLOS,EXISTE_LAD,MURO
PUBLIC MINUT2,MINUT1,SEGUN2,SEGUN1,TIEMPO,UNIDAD,DECENA,CENTENA
PUBLIC LIN1_PALA,LIN2_PALA,POSI_PALA,ANT_POSI_PALA,SENTIDO


DATOS  SEGMENT PARA PUBLIC 'DATOS'

; Variables que representan la informacin sobre el juego.
LINEA_HORI  DB '   '
            DB '   '
LINEA_VACIA DB '                                       '
            DB '                                       '
LINEA_REG1  DB '  Teclas de movimiento   :   *O* mover'  
            DB ' izquierda     *P* mover derecha  '     
LINEA_REG2  DB '  Tecla de fin del juego :   *F*      '
            DB '                                  '
LINEA_REG3  DB '  Teclee su nombre y pulse Intro : -  '
            DB '      -                           '
LINEA_INFO  DB ' Nombre:            Jugadas:    ARKANOID  '
            DB ' Ptos: 000  Tiempo:  :    '

; Mensaje para continuar el juego.
MENSA_CONTINUAR DB 'Pulsar C para continuar'

; Mensaje de fin de juego.
LINEA_FINAL DB ' Has conseguido     puntos !. Gracias por jugar'

MURO    DB'ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵ'  ;Contenido inicial del
        DB'ƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ'  ;muro.
        DB'ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵ'
        DB'ƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ'
        DB'̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹'
        DB'̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹'
        DB'̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹'
        DB'̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹'
        DB'ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵ'
        DB'ƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ'
        DB'ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵ'
        DB'ƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ'
        DB'̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹'
        DB'̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹'
        DB'̹̹̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹'
        DB'̹̹ƵƵƵƵ̹̹̹̹ƵƵƵƵ̹̹̹̹'

TABLA   DB 27,'1234567890-='                  ;Tabla que codifica los
        DB 8,9,'QWERTYUIOP[]',13,'*'          ;caracteres del teclado.
        DB 'ASDFGHJKL$;$','*'
        DB '<ZXCVBNM,.-','*'
        DB' ','*'
        DB ' ', 13 DUP ('*')
        DB '789-456+1230'

REL_IP  DW ?     ;Variables que contienen los antiguos CS e IP de la
REL_CS  DW ?     ;rutina de atencin al reloj.
TEC_IP  DW ?     ;Variables que contienen los antiguos CS e IP de la
TEC_CS  DW ?     ;rutina de atencin al teclado.

CUATRO    DB 4   ;Cada cuatro interrupciones de reloj dibuja la pelota.
TRES      DB 3   ;Cada tres interrupciones de reloj dibuja la pelota.
FIL_PELO  DB 24  ;Variables que contienen la posicin (i,j) de
COL_PELO  DB 80  ;la pelota.
PELOTA_X  DW -1  ;Sentido en el eje X de la pelota (-1,0,1).
PELOTA_Y  DW -1  ;Sentido en el eje Y de la pelota (-1,1).
VELOCIDAD_PEL  DB 1   ;Indica cada cuntas interrupcines de reloj
                      ;se dibuja la pelota en pantalla.

LIN1_PALA   DB 'ͻ'   ;Variables que representan por pantalla
LIN2_PALA   DB 'ͼ'   ;a la raqueta.
POSI_PALA     DB 34    ;Contiene la actual posicin de la pelota.
ANT_POSI_PALA DB 34    ;Contiene la anterior posicin de la raqueta.
SENTIDO       DB 0     ;Sentido en el eje X de la raqueta (1,2).

EXISTE_LAD    DB 0     ;Indica si en la posicin dada hay un ladrillo.
NUM_LADRILLOS DB 36    ;Nmero inicial de ladrillos.

NOM       DB '        ';Variable que contendr el nombre del jugador.
DIRPAN    DW ?         ;Contiene el modo video del monitor.

FIN_JUEGO DB ?     ;Cuando es una 'F' (33) acaba el juego.
NUM_VIDAS DB 3     ;Nmero de vidas por consumir.

TIEMPO      DB 0   ;Variable que se incrementa en cada interrupcin
                   ;del reloj.
TIEMPO_PASA DB 0   ;Si es un 1 transcurre el marcador del tiempo, y
                   ;si es un 0 el marcador del tiempo se para.
CAR_PELO    DB 124 ;Variable que representa a la pelota mientras se
                   ;est en modo pausa.
EJEC_BUCLE  DB 0   ;Sirve para ejecutar en cada interrupcin del reloj
                   ;el bucle del programa principal.

;en la documentacin explicarlo.
ZONA_PANTALLA DB ? ;Codifica el lugar en que sen encuentra la pelota
                   ;dentro de la pantalla (1,2,3,4,5,6).

MINUT1      DB 0   ;Variables que contienen
MINUT2      DB 0   ;el tiempo transcurrido
SEGUN1      DB 0   ;desde el comienzo
SEGUN2      DB 0   ;del juego.

UNIDAD      DB 0   ;Variables que contienen
DECENA      DB 0   ;el marcador de puntos
CENTENA     DB 0   ;hasta el final del juego.

DATOS       ENDS


CODIGO SEGMENT PARA PUBLIC 'CODIGO'
       ASSUME CS:CODIGO,DS:DATOS,SS:PILA,ES:PANTALLA


ARKANO4 PROC FAR

; Para volver al DOS primero se empila la @ de retorno.
       PUSH DS            ;Se empila el seg. de datos del DOS.
       SUB  AX,AX         ;AX:=0.
       PUSH AX            ;Se empila el desplazamiento (0).

       MOV AX,DATOS
       MOV DS,AX          ;Se inicializa nuestro seg. de datos.

       CALL DIR_PANT      ;Calculamos la @ de comienzo de la pantalla.
       MOV ES,AX          ;Se inicializa el seg. extra, ES:= @ pantalla.

       CALL PRESENT1      ;Presentacion inicial del juego.



       CALL LEER_NOM      ;Subrutina que escribe el nombre del jugador
                          ;por pantalla y lo guarda en la variable NOM.

       CALL DIB_MURO      ;Subrutina que dibuja el muro por pantalla.

       CALL PRESENT2      ;Escribimos la linea permanente de informacin 
                          ;sobre el estado del juego.


 

       CALL ALEATORIO     ;D un valor aleatorio a la pelota.

       CALL ESCR_NOM      ;Escribimos de la variable NOM el nombre.

       CALL DIB_PALA      ;Dibuja la raqueta.

       PUSH ES            ;Guardamos la @base de la pantalla.
       CALL CAMBIAR_V_I   ;Cambiamos el vector de interrupciones.
       POP  ES            ;En ES @base de pantalla para ESCR_CAR.

       MOV  TIEMPO_PASA,1 ;Habilito el marcador del tiempo.


;******************** EMPIEZA EL PROGRAMA PRINCIPAL ********************
BUC1:  CMP  FIN_JUEGO,33  ;Bucle que sirve para poder se interrunpidos.
       JZ   FIN_PROG_PRINC
       CMP  EJEC_BUCLE,1
       JNZ  BUC1
                          ;Actualizo variable para ejecutar el bucle del
       MOV  EJEC_BUCLE,0  ;Prog. Principal despus de la siguente 
                          ;interrupcin de reloj.

       CALL PEGA_PAR      ;Deja en ZONA_PANTALLA el lugar donde se
       CALL LUGAR_PELOTA  ;encuentra la pelota (0,1,2,3,4,5,6,7).



    

       CALL PEGA_RAQ      ;Pega la pelota con la raqueta?.

    CALL PEGA_LAD      ;Pega la pelota con algn ladrillo?.

       MOV  AX,32         ;AX := ' '.
       PUSH AX            ;Borro la pelota en  la
       CALL ACTUALIZAR_PELOTA  ;actual posicin.

       CALL POSICION_PELOTA ;Calculo la nueva posicin de la pelota.

       MOV  AX,236        ;AX := ''.
       PUSH AX            ;Dibujo la pelota en 
       CALL ACTUALIZAR_PELOTA ;la nueva posicin.

       JMP  BUC1
;******************** TERMINA EL PROGRAMA PRINCIPAL ********************

FIN_PROG_PRINC:
       CALL MENSA_FINAL   ;Escribo el mensaje final.
       CALL RESTAURAR_V_I ;Restaurar el vector de interrupciones.
       RET

ARKANO4 ENDP


; Rutina que realiza la presentacin inicial del juego.
PRESENT1 PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;Salvar registros.

       MOV  BX,03H        ;BX:=atributo.
       MOV  DI,0          ;Inicializo el contador de filas.
WHILE1:CMP  DI,25
       JZ   FINAL1        ;Si fila=25 => FIN1.
       MOV  SI,0          ;Inicializo el contador de columnas.

WHILE2:CMP  SI,80
       JZ   FIN2          ;Si columna=80 => FIN2
       CMP  DI,0
       JZ   L_HOR         ;Si fila=0  => escribo linea horizontal.
       CMP  DI,24
       JZ   L_HOR         ;Si fila=24 => escribo linea horizontal.
       MOV  AL,DS:LINEA_VACIA[SI] ;Sino escribo la linea vacia.
       JMP  CONTI
L_HOR: MOV  AL,DS:LINEA_HORI[SI]  ;Escribo linea horizontal.

CONTI: PUSH BX            ;Empilar el atributo.
       PUSH AX            ;Empilar el caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.
       JMP  WHILE2
FIN2:  INC  DI            ;Incrementar la fila.
       JMP  WHILE1

; Escribir reglas del juego.
FINAL1:MOV  BX,0FH        ;BX:=atributo.
       MOV  DI,12         ;Inicializo el contador de filas.
       MOV  SI,4          ;Inicializo el contador de columnas.

WH3:   CMP  SI,76
       JZ   FIN3
       CMP  DI,12
       JZ   REG1
       CMP  DI,13
       JZ   REG2
       JMP  REG3
REG1:  MOV  AL,DS:LINEA_REG1[SI-4]  ;Escribir datos y continuar.
       JMP  EMPI
REG2:  MOV  AL,DS:LINEA_REG2[SI-4]  ;Escribir datos y continuar.
       JMP  EMPI
REG3:  MOV  AL,DS:LINEA_REG3[SI-4]  ;Escribir datos y continuar.

EMPI:  PUSH BX            ;Empilar el atributo.
       PUSH AX            ;Empilar el caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.
       JMP  WH3

FIN3:  CMP  DI,14
       JZ   FINFIN
       MOV  SI,4
       INC  DI            ;Incrementar la fila.
       JMP  WH3

; Para borrar el cursor pongo en negro la 1 columna de la pantalla.
FINFIN:MOV  SI,0          ;Inicializar filas.
CURSOR:MOV  AX,00H
       PUSH AX            ;Empilar el atributo.
       PUSH AX            ;Empilar el caracter.
       PUSH AX            ;Empilar la columna.
       PUSH SI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la fila.
       CMP  SI,25
       JL   CURSOR

       POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
PRESENT1 ENDP


; Subrutina que cambia las RUTINAS DE SERVICIO del reloj y del teclado
; del DOS por las nuevas (LEECAR_I y RELOJINT).
CAMBIAR_V_I PROC NEAR 
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX            ;Salvar registros.

INHIB1:CLI                ;Inhibir interrupciones.
       XOR  AX,AX
       MOV  ES,AX         ;ES apunta al comienzo del vector de interrup.
       MOV  BX,1CH*4      ;@ del IP de la rut. de aten. del reloj (8).
       MOV  AX,ES:[BX]
       MOV  DS:REL_IP,AX  ;En REL_IP el IP anterior (DOS).
       MOV  AX,OFFSET RELOJINT
       MOV  ES:[BX],AX    ;Actualizo dicha entrada con la nueva @IP.
       MOV  AX,ES:[BX+2]
       MOV  DS:REL_CS,AX  ;En REL_CS el CS anterior (DOS).
       MOV  AX,SEG RELOJINT
       MOV  ES:[BX+2],AX  ;Actualzo dicha entrada con la nueva@ CS.

       XOR  AX,AX
       MOV  ES,AX         ;ES apunta al comienzo del vector de interrup.
       MOV  BX,9*4        ;@ del IP de la rut. de aten. del teclado (9).
       MOV  AX,ES:[BX]
       MOV  DS:TEC_IP,AX  ;En TEC_IP el IP anterior (DOS).
       MOV  AX,OFFSET LEECAR_I
       MOV  ES:[BX],AX    ;Actualizo dicha entrada con la nueva @IP.
       MOV  AX,ES:[BX+2]
       MOV  DS:TEC_CS,AX  ;En TEC_CS el CS anterior (DOS).
       MOV  AX,SEG LEECAR_I
       MOV  ES:[BX+2],AX  ;Actualizo dicha entrada con la nueva @CS.
       STI                ;Habilitar las interrupciones.

       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
CAMBIAR_V_I ENDP


; Subrutina que reestablece las RUTINAS DE SERVICIO del reloj y del
; teclado del DOS.
RESTAURAR_V_I PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX            ;Salvar registros.

       CLI                ;Inhibir interrupciones.
       XOR  AX,AX
       MOV  ES,AX
       MOV  BX,1CH*4
       MOV  AX,REL_IP
       MOV  ES:[BX],AX
       MOV  AX,REL_CS
       MOV  ES:[BX+2],AX

       XOR  AX,AX
       MOV  ES,AX
       MOV  BX,9*4
       MOV  AX,TEC_IP
       MOV  ES:[BX],AX
       MOV  AX,TEC_CS
       MOV  ES:[BX+2],AX
       STI                ;Habilitar interrupciones.

       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
RESTAURAR_V_I ENDP


; Subrutina que escribe en la pantalla  el nombre del jugador tecleado
; que se ha guardado en la variable NOM.
ESCR_NOM PROC NEAR         
       PUSH BP             
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH SI
       PUSH DI            ;Salvar registros.

       MOV  DI,23
       MOV  SI,0
WHNOM: CMP  SI,8
       JZ   FINOM         ;Si SI=80 => FINOM.
       MOV  AX,0AH
       PUSH AX            ;Empilar el atributo.
       MOV  AL,DS:NOM[SI]
       PUSH AX            ;Empilamos el carcter.
       MOV  AX,SI
       ADD  AX,13
       PUSH AX            ;Empilamos la columna.
       PUSH DI            ;Empilamos la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.
       JMP  WHNOM

FINOM: POP  DI
       POP  SI
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
ESCR_NOM ENDP


; Rutina que dibuja el muro por pantalla.
DIB_MURO PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;Salvar registros.

       MOV  SI,0
       MOV  DI,0          ;Inicializar los ndices.

COMP8: CMP  SI,8
       JGE  SIMAY
COMP73:CMP  DI,72
       JGE  DIMAY
       MOV  AX,4FH
       PUSH AX            ;Empilar atributo.

       MOV  AX,72
       MUL  SI
       ADD  AX,DI
       MOV  BX,AX
       MOV  AL,DS:MURO[BX] ;AX := caracter a empilar.

       PUSH AX            ;Empilar caracter.
       MOV  AX,DI
       ADD  AX,4
       PUSH AX            ;Empilar la columna.
       MOV  AX,SI
       INC  AX
       PUSH AX            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  DI
       JMP  COMP73

DIMAY: MOV  DI,0
       INC  SI
       JMP  COMP8

SIMAY: POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
DIB_MURO ENDP


; Rutina que da un valor aleatorio a la posicin de la pelota
; en el eje X, en el eje Y ser 17.
ALEATORIO PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX            ;Salvar registros.

       MOV  AL,TIEMPO
       MOV  BX,4
       MUL  BX            ;AX:=TIEMPO*4.
       ADD  AX,4          ;AX:=(TIEMPO*4)+4.
       MOV  COL_PELO,AL   ;COL_PLEO:=(TIEMPO*4)+4.

       MOV  FIL_PELO,17

       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
ALEATORIO ENDP


; Rutina que comprueba en qu lugar de la pantalla se encuentra
; la pelota.
LUGAR_PELOTA PROC NEAR
       PUSH BP
       MOV  BP,SP           ;Enlace dinmico.

       CMP  ZONA_PANTALLA,1
       JNZ  COMP2
       MOV  PELOTA_X,1      ;Si ZONA_PANTALLA=1 cambio el sentido de la
       JMP  ACABAR          ;pelota en el eje X.

COMP2: CMP  ZONA_PANTALLA,2
       JNZ  COMP3
       MOV  PELOTA_Y,1      ;Si ZONA_PANTALLA=2 cambio el sentido de la
       JMP  ACABAR          ;pelota en el eje Y.

COMP3: CMP  ZONA_PANTALLA,3
       JNZ  CMP5
       MOV  PELOTA_X,-1     ;Si ZONA_PANTALLA=3 cambio el sentido de la
       JMP  ACABAR          ;pelota en el eje X.

CMP5:  CMP  ZONA_PANTALLA,5
       JNZ  COMP6
       MOV  PELOTA_X,1      ;Si ZONA_PANTALLA=5 cambio el sentido de la
       MOV  PELOTA_Y,1      ;pelota en el eje X y el eje Y.
       JMP  ACABAR

COMP6: CMP  ZONA_PANTALLA,6
       JNZ  ACABAR
       MOV  PELOTA_X,-1     ;Si ZONA_PANTALLA=6 cambio el sentido de la
       MOV  PELOTA_Y,1      ;pelota en el eje X y el eje Y.

ACABAR:POP  BP              ;Restaurar emlace dinmico.
       RET
LUGAR_PELOTA ENDP


; Rutina que escribe por pantalla, en la posicin de la pelota,
; un caracter.
ACTUALIZAR_PELOTA PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Guardar registros.

       CMP  FIN_JUEGO,33  ;Si se ha acabado el juego no actualizo
       JZ   FINII         ;la pelota.

       MOV  AX,0EH
       PUSH AX            ;Empilo el atributo.
       MOV  AX,[BP+4] 
       PUSH AX            ;Empilo el caracter ''  ' '.
       MOV  AL,COL_PELO
       PUSH AX            ;Empilo la columna.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

FINII: POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar emlace dinmico.
       RET  2             ;Retornar eliminando parmetro.
ACTUALIZAR_PELOTA  ENDP


; Rutina que actualiza la posicin de la pelota dependiendo del
; sentido de su movimiento.
POSICION_PELOTA PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX            ;Salvar registros.

       MOV  AX,PELOTA_X
       CMP  AX,1
       JNZ  PELO__1
       MOV  AL,COL_PELO
       INC  AL            ;Si PELOTA_X=1 incremento la posicin de la
       MOV  COL_PELO,AL   ;pelota en el eje X.
       JMP  PELOTA_Y?

PELO__1:CMP AX,-1
       JNZ  PELOTA_Y?
       MOV  AL,COL_PELO
       DEC  AL            ;Si PELOTA_X=-1 decremento la posicin de la
       MOV  COL_PELO,AL   ;pelota en el eje X.

PELOTA_Y?:MOV AX,PELOTA_Y
       CMP  AX,1
       JNZ  PELOTA__1
       MOV  AL,FIL_PELO
       INC  AL            ;Si PELOTA_Y=1 incremento la posicin de la
       MOV  FIL_PELO,AL   ;pelota en el eje Y.
       JMP  FINALIZAR

PELOTA__1:MOV AL,FIL_PELO
       DEC AL             ;Si PELOTA_Y=-1 decremento la posicin de la
       MOV FIL_PELO,AL    ;pelota en el eje Y.

FINALIZAR:POP  AX         ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
POSICION_PELOTA ENDP


; Rutina que escribe en pantalla un mensaje de fin de juego, indicando
; la puntuacin conseguida.
; Tambin apaga el posible sonido del altavoz.
MENSA_FINAL PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinamico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;Salvar registros.

; Escribe el mensaje final.
       MOV  DI,10
       MOV  SI,0
       MOV  BX,1FH        ;BX:=atriburo.
COMP5: MOV  AL,DS:LINEA_FINAL[SI]
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar caracter.
       MOV  AX,SI
       ADD  AX,15
       PUSH AX            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI
       CMP  SI,48
       JNZ  COMP5

; Escibe la puntuacin alcanzada.
       MOV  AL,CENTENA    ;Escribo las centenas.
       OR   AL,30H
       MOV  BX,9FH
       PUSH BX
       PUSH AX
       MOV  BX,32
       PUSH BX
       PUSH DI
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  AL,DECENA
       OR   AL,30H
       MOV  BX,9FH
       PUSH BX
       PUSH AX
       MOV  BX,33
       PUSH BX
       PUSH DI
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  AL,UNIDAD    ;Escribo las unidades.
       OR   AL,30H
       MOV  BX,9FH
       PUSH BX
       PUSH AX
       MOV  BX,34
       PUSH BX
       PUSH DI
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

; Para quitar el sonido cuando se han acabado todas las vidas, o cuando
       IN   AL,61H        ;la pelota choca con el ltimo ladrillo, o
       AND  AL,11111100B  ;cuando se pulsa  'F'. Todo esto sin haber
       OUT  61H,AL        ;pasado por la rutina de reloj.

       POP  DI
       POP  SI
       POP  BX
       POP  AX                    ;restaurar registros
       POP  BP                    ;restaurar enlace dinamico
       RET
MENSA_FINAL ENDP


; Rutina que escribe la linea de informacin permanente del juego.
PRESENT2 PROC NEAR
       PUSH BP
       MOV  BP,SP         ;enlace dinamico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;salvar registros.

; Borrar las lineas iniciales de reglas del juego.
       MOV  BX,03H
       MOV  DI,12
       MOV  SI,1          ;Inicializar el contador de columnas.
WH2:   CMP  SI,79
       JZ   SEGUIR        ;Si columna=80 => FIN2.
       
       PUSH BX            ;Empilar el atributo.
       MOV  AL,DS:LINEA_VACIA[SI]
       PUSH AX            ;Empilar el caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.
       JMP  WH2
       
SEGUIR:INC  DI            ;Incrementar la fila.
       MOV  SI,1
       CMP  DI,16
       JNZ  WH2
       
       MOV  DI,22
       MOV  SI,0
COMP:  MOV  AL,DS:LINEA_HORI[SI]
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.
       CMP  SI,80
       JNZ  COMP          ;Si columna=80 => FINAL.
       
       MOV  DI,23
       MOV  SI,4
       MOV  BX,0FH
COMP1: MOV  AL,DS:LINEA_INFO[SI-4]
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI            ;Incrementar la columna.

       CMP  SI,76
       JNZ  COMP1
       
; Escribir el nmero inicial de vidas.
       MOV AX,0AH
       PUSH AX            ;Empilar atributo.
       MOV  AL,51
       PUSH AX            ;Empilar caracter.
       MOV  AX,33
       PUSH AX            ;Empilar la columna.
       MOV  AX,23
       PUSH AX            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       MOV  DI,4          ;Inicializar columnas.
SEGUIR1:MOV AX,03H
       PUSH AX            ;Empilar atributo.
       MOV  AX,223
       PUSH AX            ;Empilar caracter.
       PUSH DI            ;Empilar la columna.
       MOV  AX,24
       PUSH AX            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  DI
       CMP  DI,76
       JL   SEGUIR1
   
       POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinamico.
       RET
PRESENT2 ENDP


CODIGO ENDS
       END ARKANO4
