; Fichero LEER_NOM.ASM 
; Rutina que recoge el nombre del jugador que  hemos tecleado y lo
; escribe en la pantalla.

TITLE LEER_NOM

; Rutinas FAR que utiliza LEER_NOM:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN LEECAR_E:FAR    ;Rutina que lee un carcter del teclado.

; Variables globales que utiliza LEER_NOM:
EXTRN TABLA:BYTE      ;Tabla que codifica los caracteres del teclado.
EXTRN NOM:BYTE        ;Variable que contendr el nombre del jugador.


CODIGO SEGMENT PARA PUBLIC
       ASSUME CS:CODIGO

PUBLIC   LEER_NOM
LEER_NOM PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH SI            ;Salvar registros.

;Inhibir las interrupciones del teclado.
       MOV SI,0           ;Inicializo el contador de letras del nombre.
       IN  AL,021H        ;Leer IMR del controlador de interrupciones.
       OR  AL,02H
       OUT 21H,AL         ;Poner a 1 el 2 bit de IMR.

ENCU:  MOV  AL,0AH
       OUT  20H,AL        ;Seleccin del IRR en el registro de control.
       IN   AL,20H        ;AL:=IRR , leyendo el registro de control.
       TEST AL,02H        ;AL(1)=1?
       JZ   ENCU

       CALL LEECAR_E      ;Devuelve en AL el cdigo de ratreo.

       CMP  AL,28         ;Caso de ser el cdigo 28(Intro) => termina.
       JZ   FIN

       CMP  AL,-1         ;Si es -1, sera un "BREAK" y lo ignoro.
       JZ   ENCU

; Traduccin de la tecla pulsada.
       SUB  AL,1
       MOV  BX,OFFSET TABLA;BX:=offset de TABLA.
       XLAT                ;AL:=carcter.
       ADD  BX,OFFSET NOM
       MOV  NOM[SI],AL     ;Escribo la letra en la variable NOM.

; Escritura en pantalla del nombre del jugador.
       MOV  BX,0EH
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar el carcter.
       MOV  AX,40
       ADD  AX,SI
       PUSH AX            ;Empilar la columna.
       MOV  AX,14
       PUSH AX            ;Empilar la fila.

       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       CMP  SI,7
       JZ   ENCU
       INC  SI            ;Posicin para la siguiente letra.
       JMP  ENCU          ;leer otro carcter.

FIN:   IN   AL,21H        ;Acceder al IMR.
       AND  AL,11111101B
       OUT  21H,AL        ;Habilitar las interrupciones del teclado.

       POP SI
       POP BX
       POP AX             ;Restaurar registros.
       POP BP             ;Restaurar enlace dinmico.
       RET 

LEER_NOM ENDP
CODIGO   ENDS
         END
