; Fichero PEGA_LAD.ASM
; Rutina que comprueba si la pelota choca con algn ladrillo, y si
; es as cambia su sentido y velocidad, borra el ladrillo, e incrementa
; el marcador de los ptos.

TITLE PEGA_LAD   

; Rutinas NEAR que utiliza PEGA_LAD:
; SENTIDO_UNO, SENTIDO_DOS, SENTIDO_TRES, SENTIDO_CUATRO, SENTIDO_SEIS
; HAY_LAD, EXISTE_LAD, LUGARLAD, BORRALAD, PTOS.

; Rutinas FAR que utiliza  PEGA_LAD:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN SONIDO:FAR      ;Rutina que activa el altavoz del PC.

; Variables globales que utiliza PEGA_LAD:
EXTRN FIL_PELO:BYTE      ;Variables que contienen la posicin (i,j) de
EXTRN COL_PELO:BYTE      ;la pelota.
EXTRN PELOTA_X:WORD      ;Sentido en el eje X de la pelota (-1,0,1).
EXTRN PELOTA_Y:WORD      ;Sentido en el eje Y de la pelota (-1,1).
EXTRN VELOCIDAD_PEL:BYTE ;Indica cada cuntas interrupcines de reloj
                         ;se dibuja la pelota en pantalla.
EXTRN EXISTE_LAD:BYTE    ;Indica si en la posicin dada hay un ladrillo.
EXTRN NUM_LADRILLOS:BYTE ;Nmero de ladrillos.
EXTRN FIN_JUEGO:BYTE     ;Cuando es una 'F' (33) acaba el juego.

EXTRN UNIDAD:BYTE        ;Variables que contienen
EXTRN DECENA:BYTE        ;el marcador de puntos
EXTRN CENTENA:BYTE       ;hasta el final del juego.


CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC   PEGA_LAD
PEGA_LAD PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Guardar registros.

       CMP  FIL_PELO,9    ;Si la pelota no est en una zona donde pudiera
       JG   FINAL         ;haber ladrillos salimos de la rutina.

; Esto es necesario para saber en cual de los 6 sentidos posibles se
; est moviendo la pelota.
       CMP  PELOTA_X,-1   
       JNE  X_0_1         

       CMP  PELOTA_Y,-1
       JNE  IV
       CALL SENTIDO_UNO   ;Cuando se mueve hacia el Noroeste.
       JMP  FINAL

X_0_1: CMP  PELOTA_X,0       
       JNE  X_1

       CMP  PELOTA_Y,-1
       JNE  V
       CALL SENTIDO_DOS   ;Cuando se mueve al Norte.
       JMP  FINAL

X_1:   CMP  PELOTA_Y,-1
       JNE  VI

       CALL SENTIDO_TRES  ;Cuando se mueve hacia el Noreste.
       JMP  FINAL

IV:    CALL SENTIDO_CUATRO;Cuando se mueve hacia el Suroeste. 
       JMP  FINAL

VI:    CALL SENTIDO_SEIS  ;Cuando se mueve hacia el Sureste.

V:     ;Como la pelota cuando se muve verticalmente hacia abajo nunca
       ;se va ha encontrar un ladrillo, no pongo nada.

FINAL: POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinmico.
       RET
       
PEGA_LAD ENDP

; Subrutina que resulve el posible choque de la pelota con algn
; ladrillo cuando se mueve hacia el Noroeste.
SENTIDO_UNO PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Eenlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AL,COL_PELO
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la izquierda?
       CMP  EXISTE_LAD,1
       JNZ  SINO1         ;Nno hay ladrillo a la izquierda.
              
       MOV  AL,COL_PELO   ;Hay un ladrillo a la izquierda.
       DEC  AX
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,1    ;Cambio la pelota de sentido.
       
       MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AL
       PUSH AX            ;Empilo fila-1.
       CALL HAY_LAD       ;Hay algn ladrillo arriba?
       CMP  EXISTE_LAD,1
       JNZ  FINAL1        ;No hay ladrillo arriba.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo arriba.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,1    ;Cambio la pelota de sentido.
       JMP  FINAL1

SINO1: MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AL
       PUSH AX            ;Empilo fila-1.
       CALL HAY_LAD       ;Hay algn ladrillo arriba?
       CMP  EXISTE_LAD,1
       JNZ  SINO2         ;No hay ladrillo arriba.

       MOV  AL,COL_PELO   ;Hay un ladrillo arriba.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.

       MOV  PELOTA_Y,1    ;Cambio la pelota de sentido.
       JMP  FINAL1

SINO2: MOV  AL,COL_PELO
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL HAY_LAD       ;Hay algn ladrillo enfrente?
       CMP  EXISTE_LAD,1
       JNZ  FINAL1        ;No hay ladrillo en frente.

       MOV  AL,COL_PELO   ;Hay un ladrillo en frente.
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,1    ;Cambio la pelota de sentido.
       MOV  PELOTA_Y,1 

FINAL1:POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
SENTIDO_UNO ENDP

; Subrutina que resulve el posible choque de la pelota con algn
; ladrillo cuando se mueve hacia el Norte.
SENTIDO_DOS PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AL
       PUSH AX            ;Empilo fila-1.
       CALL HAY_LAD       ;Hay algn ladrillo arriba?
       CMP  EXISTE_LAD,1
       JNZ  FINAL2        ;No hay ladrillo arriba.

       MOV  AL,COL_PELO   ;Hay un ladrillo arriba.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,1    ;Cambio la pelota de sentido.

FINAL2:POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
SENTIDO_DOS ENDP

; Subrutina que resulve el posible choque de la pelota con algn
; ladrillo cuando se mueve hacia el Noreste.
SENTIDO_TRES PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AL
       PUSH AX 
       CALL HAY_LAD       ;Hay algn ladrillo arriba?
       CMP  EXISTE_LAD,1
       JNZ  SINO11        ;No hay ladrillo arriba.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo arriba.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,1    ;Cambio la pelota de sentido.
       
       MOV  AL,COL_PELO
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la derecha?
       CMP  EXISTE_LAD,1
       JNZ  FINAL12       ;No hay ladrillo a la derecha.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo a la derecha.
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,-1   ;Cambio la pelota de sentido.
       JMP  FINAL12

SINO11:MOV  AL,COL_PELO
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la derecha?
       CMP  EXISTE_LAD,1
       JNZ  SINO22        ;No hay ladrillo a la derecha.

       MOV  AL,COL_PELO   ;Hay un ladrillo a la derecha.
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,-1   ;Cambio la pelota de sentido.
       JMP  FINAL12

SINO22:MOV  AL,COL_PELO
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL HAY_LAD       ;Hay algn ladrillo enfrente?
       CMP  EXISTE_LAD,1
       JNZ  FINAL12       ;No hay ladrillo en frente.

       MOV  AL,COL_PELO   ;Hay un ladrillo en frente.
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       DEC  AX
       PUSH AX            ;Empilo fila-1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,-1   ;Cambio la pelota de sentido.
       MOV  PELOTA_Y,1 

FINAL12:POP AX           ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
SENTIDO_TRES ENDP

; Subrutina que resulve el posible choque de la pelota con algn
; ladrillo cuando se mueve hacia el Suroeste.
SENTIDO_CUATRO PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AL
       PUSH AX            ;Empilo fila+1.
       CALL HAY_LAD       ;Hay algn ladrillo debajo?
       CMP  EXISTE_LAD,1
       JNZ  SINO33        ;No hay ladrillo debajo.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo debajo.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AX
       PUSH AX            ;Empilo fila+1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,-1   ;Cambio la pelota de sentido.
       
       MOV  AL,COL_PELO
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la izquierda?
       CMP  EXISTE_LAD,1
       JNZ  FINAL14       ;No hay ladrillo a la izquierda.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo a la izquierda.
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,1    ;Cambio la pelota de sentido.
       JMP  FINAL14

SINO33:MOV  AL,COL_PELO
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la izquierda?
       CMP  EXISTE_LAD,1
       JNZ  SINO44       ;No hay ladrillo a la izquierda.

       MOV  AL,COL_PELO   ;Hay un ladrillo a la izquierda.
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,1    ;Cambio la pelota de sentido.
       JMP  FINAL14

SINO44:MOV  AL,COL_PELO
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       INC  AX
       PUSH AX            ;Empilo fila+1.
       CALL HAY_LAD       ;Hay algn ladrillo enfrente?
       CMP  EXISTE_LAD,1
       JNZ  FINAL14       ;No hay ladrillo en frente.

       MOV  AL,COL_PELO   ;Hay un ladrillo en frente.
       DEC  AL
       PUSH AX            ;Empilo columna-1.
       MOV  AL,FIL_PELO
       INC  AX
       PUSH AX            ;Empilo fila+1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,1    ;Cambio la pelota de sentido
       MOV  PELOTA_Y,-1 

FINAL14:POP AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
SENTIDO_CUATRO ENDP

; Subrutina que resulve el posible choque de la pelota con algn
; ladrillo cuando se mueve hacia el Sureste.
SENTIDO_SEIS PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AL,COL_PELO
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL HAY_LAD       ;Hay algn ladrillo a la derecha?
       CMP  EXISTE_LAD,1
       JNZ  SINO55        ;No hay ladrillo a la derecha.
       
       MOV  AL,COL_PELO   ;hay un ladrillo a la derecha.
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilo fila.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,-1   ;Cambio la pelota de sentido.
       
       MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AL
       PUSH AX            ;Empilo fila+1.
       CALL HAY_LAD       ;Hay algn ladrillo abajo?
       CMP  EXISTE_LAD,1
       JNZ  FINAL16       ;No hay ladrillo abajo.
       
       MOV  AL,COL_PELO   ;Hay un ladrillo abajo.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AL
       PUSH AX            ;Empilo fila+1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,-1   ;Cambio la pelota de sentido.
       JMP  FINAL16

SINO55:MOV  AL,COL_PELO
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AL
       PUSH AX            ;Empilo fila+1.
       CALL HAY_LAD       ;Hay algn ladrillo abajo?
       CMP  EXISTE_LAD,1
       JNZ  SINO66        ;No hay ladrillo abajo.

       MOV  AL,COL_PELO   ;Hay un ladrillo abajo.
       PUSH AX            ;Empilo columna.
       MOV  AL,FIL_PELO
       INC  AL
       PUSH AX            ;Empilo fila+1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_Y,-1   ;Cambio la pelota de sentido.
       JMP  FINAL16

SINO66:MOV  AL,COL_PELO
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       INC  AX
       PUSH AX            ;Empilo fila+1.
       CALL HAY_LAD       ;Hay algn ladrillo enfrente?
       CMP  EXISTE_LAD,1
       JNZ  FINAL16       ;No hay ladrillo enfrente.

       MOV  AL,COL_PELO   ;Hay un ladrillo enfrente.
       INC  AL
       PUSH AX            ;Empilo columna+1.
       MOV  AL,FIL_PELO
       INC  AX
       PUSH AX            ;Empilo fila+1.
       CALL LUGARLAD      ;Borro el ladrillo que hay.
       MOV  PELOTA_X,-1   ;Cambio la pelota de sentido.
       MOV  PELOTA_Y,-1 

FINAL16:POP AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
SENTIDO_SEIS ENDP

; Subrutina que comprueba si a partir de los parmetros que se le
; pasan (fila,columna) hay un ladrillo.
HAY_LAD PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH CX            ;Salvar registros.

       MOV  AX,[BP+4]     ;Recoger la fila.
       MOV  CX,80
       MUL  CX            ;AX:=i*80.
       ADD  AX,[BP+6]     ;AX:=(i*80)+j.
       SAL  AX,1          ;AX:=2((i*80)+j).
       MOV  BX,AX
       MOV  AX,ES:[BX]    ;AX:=el carcter en la posicin (i,j).

       CMP  AL,0B5H
       JZ   HAYLADRILLO
       CMP  AL,0B9H
       JZ   HAYLADRILLO
       CMP  AL,0C6H
       JZ   HAYLADRILLO
       CMP  AL,0CCH
       JZ   HAYLADRILLO
       MOV  EXISTE_LAD,0  ;No hay ladrillo.
       JMP  FIN
       
HAYLADRILLO:
       MOV  AX,3000
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       MOV  EXISTE_LAD,1

FIN:   POP  CX
       POP  BX
       POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  4             ;Retornar eliminando parmetros.
HAY_LAD ENDP

; Subrutina que averigua el lugar en pantalla del ladrillo y lo borra
; cambiando la velocidad de la pelota, dependiendo de su posicin.
LUGARLAD PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Salvar registros.

       MOV  AX,[BP+4]     ;AX:=fila.
       CMP  AX,2
       JG   CMP4

       MOV  VELOCIDAD_PEL,4;Actualizo la velocidad de la pelota.
       MOV  AX,1
       PUSH AX            ;Empilar parametro fila para BORRALAD.
       MOV  AX,20
       PUSH AX            ;Empilar parmetro puntos.
       CALL PTOS          ;Incrmentar el marcador de puntuacin.
       JMP  COL_

CMP4:  CMP  AX,4
       JG   CMP6
       
       MOV  VELOCIDAD_PEL,3;Actualizo la velocidad de la pelota.
       MOV  AX,3
       PUSH AX            ;Empilar parametro fila para BORRALAD.
       MOV  AX,15
       PUSH AX            ;Empilar parmetro puntos.
       CALL PTOS          ;Incrmentar el marcador de puntuacin.
       JMP  COL_

CMP6:  CMP  AX,6
       JG   CMP8
       
       MOV  VELOCIDAD_PEL,2;Actualizo la velocidad de la pelota.
       MOV  AX,5
       PUSH AX            ;Empilar parametro fila para BORRALAD.
       MOV  AX,10
       PUSH AX            ;Empilar parmetro puntos.
       CALL PTOS          ;Incrmentar el marcador de puntuacin.
       JMP  COL_

CMP8:  MOV  VELOCIDAD_PEL,1;Actualizo la velocidad de la pelota.
       MOV  AX,7
       PUSH AX            ;Empilar parametro fila para BORRALAD.
       MOV  AX,5
       PUSH AX            ;Empilar parmetro puntos.
       CALL PTOS          ;Incrmentar el marcador de puntuacin.

COL_:  MOV  AX,[BP+6]     ;AX:=columna.
       CMP  AX,11
       JG   CMP19
       MOV  AX,4
       PUSH AX
       JMP  LLAMADA

CMP19: CMP  AX,19
       JG   CMP27
       MOV  AX,12
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP27: CMP  AX,27
       JG   CMP35
       MOV  AX,20
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP35: CMP  AX,35
       JG   CMP43
       MOV  AX,28
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP43: CMP  AX,43
       JG   CMP51
       MOV  AX,36
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP51: CMP  AX,51
       JG   CMP59
       MOV  AX,44
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP59: CMP  AX,59
       JG   CMP67
       MOV  AX,52
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP67: CMP  AX,67
       JG   CMP75
       MOV  AX,60
       PUSH AX            ;Empilar parmetro columna para BORRALAD.
       JMP  LLAMADA

CMP75: MOV  AX,68
       PUSH AX            ;Empilar parmetro columna para BORRALAD.

LLAMADA:CALL BORRALAD     ;Borrar el ladrillo.

       POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  4             ;Retornar eliminando parmetros.
LUGARLAD ENDP

; Rutina que borra el ladrillo de la posicin (i,j) y decrementa el
; numero de ladrillos que quedan.
BORRALAD PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH CX            ;Salvar registros.

       MOV  AX,[BP+6]     ;Recoger la fila.
       MOV  CX,80
       MUL  CX            ;AX:=i*80.
       ADD  AX,[BP+4]     ;AX:=(i*80)+j.
       SAL  AX,1          ;AX:=2((i*80)+j).

       
       MOV  CX,0320H      ;CX:=caracter+atributo.
       MOV  BX,AX         ;Inicializo posicin a borrar.
       MOV  AX,0          ;Inicializo el contador de caracteres que
                          ;componen un ladrillo.
; Primera fila del ladrillo.       
FILA1: MOV  ES:[BX],CX    ;ES:[BX]:=' '.
       CMP  AX,12
       JG   FILA2
       ADD  AX,2          ;Incrementar contador de caracteres.
       ADD  BX,2          ;Incrementar posicin a borrar.
       JMP  FILA1

FILA2: ADD  BX,146        ;Actualizo posicin a borrar.
       MOV  AX,0          ;Inicializo el contador de caracteres que
                          ;componen un ladrillo.
; Segunda fila del ladrillo.
FILA21:MOV  ES:[BX],CX    ;ES:[BX]:=' '.
       CMP  AX,12
       JG   ENDD
       ADD  AX,2          ;Incrementar contador de caracteres.
       ADD  BX,2          ;Incrementar posicin a borrar.
       JMP  FILA21
       
ENDD:  MOV  AL,NUM_LADRILLOS
       DEC  AL
       MOV  NUM_LADRILLOS,AL ;Dcrementar ladrillos.
       CMP  NUM_LADRILLOS,0
       JNZ  PASAR            ;Si se han acabado los ladrillos entonces
       MOV  FIN_JUEGO,33     ;se acaba el juego.

PASAR: POP  CX
       POP  BX
       POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  4             ;Retornar eliminando parmetros.
BORRALAD ENDP

; Rutina que actualiza el marcador de los puntos de 5 en 5, es decir,
; Si se manda un 20 como parmetro la rutina se llama a si misma
; hasta que el parmetro sea un 0.
PTOS PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX      
       PUSH BX
       PUSH SI
       PUSH DI            ;Salvar registros.

; Actualizamos el marcador de puntos.
       MOV  AL,UNIDAD
       ADD  AL,5
       MOV  UNIDAD,AL
       CMP  UNIDAD,10
       JNZ  FINN
; La unidad a pasado de 9.
       MOV  UNIDAD,0
       MOV  AL,DECENA
       INC  AL
       MOV  DECENA,AL
       CMP  DECENA,10
       JNZ  FINN
; La decena a pasado de 99.
       MOV  DECENA,0
       MOV  AL,CENTENA
       INC  AL
       MOV  CENTENA,AL

FINN:  MOV  SI,58         ;SI:=columna.
       MOV  DI,23         ;DI:=fila.
       MOV  BX,0AH        ;BX:=atributo.

       MOV  AL,UNIDAD
       OR   AL,30H
       PUSH BX            ;Empilo atributo.
       PUSH AX            ;Empilo caracter.
       PUSH SI            ;Empilo columna.
       PUSH DI            ;Empilo fila.
       CALL ESCR_CAR      ;Escribo la unidad.

       DEC  SI
       MOV  AL,DECENA
       OR   AL,30H
       PUSH BX            ;Empilo atributo.
       PUSH AX            ;Empilo caracter.
       PUSH SI            ;Empilo columna.
       PUSH DI            ;Empilo fila.
       CALL ESCR_CAR      ;Escribo la decena.
       
       DEC  SI
       MOV  AL,CENTENA
       OR   AL,30H
       PUSH BX            ;Empilo atributo.
       PUSH AX            ;Empilo caracter.
       PUSH SI            ;Empilo columna.
       PUSH DI            ;Empilo fila.
       CALL ESCR_CAR      ;Escribo la centena.
       
       MOV  AX,[BP+4]     ;AX:=parmetro.
       SUB  AX,5
       MOV  [BP+4],AX     ;parmetro:=parmetro-5.
       CMP  AX,0
       JZ   NADA
       PUSH AX            ;Empilar parmetro.
       CALL PTOS          ;Llamada recursiva.

NADA:  POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Recuperar registros.
       POP  BP            ;Restaurar enlace dinnmico.
       RET  2             ;Retornar eliminando parmetro.
PTOS  ENDP

CODIGO  ENDS  
        END
