; Fichero PEGA_RAQ.ASM
; Rutina que nos dice si la pelota ha chocado con la raqueta, y si es
; as aca un mensaje en la  pantalla para que continuemos

TITLE PEGA_RAQ          

; Rutinas NEAR que utiliza PEGA_RAQ:
; ENCU_TEC2, MENSAJ_CONTI, ACTUALIZAR_VIDAS, REANUDAR_PANTALLA

; Rutinas FAR que utiliza  PEGA_RAQ:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN LEECAR_E:FAR    ;Rutina que lee un carcter del teclado.
EXTRN SONIDO:FAR      ;Rutina que activa el altavoz del PC.

; Variables globales que utiliza PEGA_RAQ:
EXTRN FIL_PELO:BYTE      ;Variables que contienen la posicin (i,j) de
EXTRN COL_PELO:BYTE      ;la pelota.
EXTRN PELOTA_X:WORD      ;Sentido en el eje X de la pelota (-1,0,1).
EXTRN PELOTA_Y:WORD      ;Sentido en el eje Y de la pelota (-1,1).
EXTRN VELOCIDAD_PEL:BYTE ;Indica cada cuntas interrupcines de reloj
                         ;se dibuja la pelota en pantalla.
EXTRN POSI_PALA:BYTE     ;Contiene la actual posisin de la raqueta.
EXTRN SENTIDO  :BYTE     ;Sentido en el eje X de la raqueta (1,2).

EXTRN MENSA_CONTINUAR:BYTE ;Mensaje para continuar el juego.
EXTRN TIEMPO_PASA:BYTE   ;Si es un 1 transcurre el marcador del tiempo,
                         ;y si es un 0 el marcador del tiempo se para.
EXTRN FIN_JUEGO:BYTE     ;Cuando es una 'F' (33) acaba el juego.
EXTRN NUM_VIDAS:BYTE     ;Nmero de vidas por consumir.


CODIGO SEGMENT PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC   PEGA_RAQ
PEGA_RAQ PROC FAR

       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Guardar registros.

       CMP  FIL_PELO,18   ;Si la fila en que se encuentra la pelota es
       JNZ  FINAL1        ;menor que 18 salimos.
       
       CMP  COL_PELO,4
       JNZ  PELO_75
       CMP  POSI_PALA,4
       JNZ  OTROCASO
       
SEGUIR:MOV  PELOTA_X,1    ;Cuando la pelota choca con la raqueta en la
       MOV  PELOTA_Y,-1   ;esquina inferior derecha.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL1
       
OTROCASO:CMP POSI_PALA,5
       JNZ  SE_SALE1      ;Si la raqueta no est en la esquina inferior
       CMP  SENTIDO,1     ;izquierda, o no est al lado y moviendo a la
       JNZ  SE_SALE1      ;la izquierda, entonces la pelota se sale.
       JMP  SEGUIR

PELO_75:CMP COL_PELO,75
       JNZ  SENTIDO_0
       CMP  POSI_PALA,65
       JNZ  OTROCASO1
       
SEGUIR1:MOV PELOTA_X,-1   ;Cuando la pelota choca con la raqueta en la
       MOV  PELOTA_Y,-1   ;esquina inferior izquierda.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL1
       
OTROCASO1:CMP POSI_PALA,64
      JNZ  SE_SALE1      ;Si la raqueta no est en la esquina inferior
       CMP  SENTIDO,2     ;derecha, o no est al lado y moviendo a la
       JNZ  SE_SALE1      ;la derecha, entonces la pelota se sale.
       JMP  SEGUIR1

FINAL1:JMP   FINAL

SENTIDO_0:CMP SENTIDO,0
       JNZ  SENTIDO_1
       MOV  AL,POSI_PALA
       CMP  AL,COL_PELO
       JG   SE_SALE1      ;La pelota se sale.
; La raqueta est parada.
       ADD  AL,10
       CMP  COL_PELO,AL
       JG   SE_SALE1      ;La pelota se sale.
       MOV  PELOTA_Y,-1   ;Como choca con la raqueta cambio su sentido.
       MOV  AX,6400
       PUSH AX
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL

SE_SALE1:JMP SE_SALE

SENTIDO_1:CMP SENTIDO,1
       JNZ  SENTIDO_2
; La raqueta se est moviendo a la izquierda.
       MOV  AL,POSI_PALA
       DEC  AL
       CMP  AL,COL_PELO       
       JG   SE_SALE1      ;La pelota se sale.
       ADD  AL,12
       CMP  COL_PELO,AL
       JG   SE_SALE1      ;La pelota se sale.
       
       CMP  PELOTA_X,1
       JNZ  PELOTA_0_1
       
       MOV  PELOTA_X,0    ;Cuando la pelota y la raqueta se mueven en
       MOV  PELOTA_Y,-1   ;sentidos contrarios y chocan.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL

PELOTA_0_1:MOV PELOTA_X,-1;Cuando la pelota y la raqueta se mueven en
       MOV  PELOTA_Y,-1   ;el mismo sentido y chocan.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL
       
; La raqueta se est moviendo a la derecha.
SENTIDO_2:MOV AL,POSI_PALA
       CMP  AL,COL_PELO
       JG   SE_SALE       ;La pelota se sale.
       ADD  AL,11
       CMP  COL_PELO,AL
       JG   SE_SALE       ;La pelota se sale.
       
       CMP  PELOTA_X,-1
       JNZ  PELOTA_X_1_0
       
       MOV  PELOTA_X,0    ;Cuando la pelota y la raqueta se mueven en
       MOV  PELOTA_Y,-1   ;sentidos contrarios y chocan.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL

PELOTA_X_1_0:MOV PELOTA_X,1;Cuando la pelota y la raqueta se mueven en
       MOV  PELOTA_Y,-1    ;el mismo sentido y chocan.
       MOV  AX,6400
       PUSH AX            ;Empilo parmetro frecuencia.
       CALL SONIDO        ;Emitir sonido.
       JMP  FINAL

SE_SALE:MOV VELOCIDAD_PEL,2  ;Si la pelota sale actualizo la velocidad
       CALL ACTUALIZAR_VIDAS ;y el nmero de vidas que quedan.
       CMP  NUM_VIDAS,0      ;Si quedan ms vidas paro el tiempo, sino
       JG   PAUSA            ;acabo la partida.
       MOV  FIN_JUEGO,33
       JMP  FINAL

PAUSA:MOV  TIEMPO_PASA,0     ;Paro el marcador del reloj.

      CALL MENSAJ_CONTI      ;Escribo mensaje para continuar.
      
      CALL ENCU_TEC2         ;Encuesta sobre el taclado hasta que se
                             ;pulse 'C'.
      CALL REANUDAR_PANTALLA ;Borro el mensaje de continuar.
      
      MOV  TIEMPO_PASA,1     ;Reanudo el marcador del reloj.
      
; Atualizo el sentido de la pelota  y la posicin de la pelota.
      MOV  PELOTA_Y,-1             
      CMP  COL_PELO,75
      JZ   EXTREMO        ;Para que la pelota no se coma la pared dcha.
      MOV  PELOTA_X,1
      JMP  FILA

EXTREMO:MOV PELOTA_X,-1
FILA:  MOV  FIL_PELO,17
FINAL: POP  AX            ;Restaurar registros.
       POP  BP            ;Restaurar enlace dinmico.
       RET
       
PEGA_RAQ ENDP


; Rutina que realiza una encuesta del teclado esperando a que se pulse
; la letra 'C'.
ENCU_TEC2 PROC NEAR
       PUSH BP
       MOV  BP,SP          ;Enlace dinmico.
       PUSH AX             ;Guardar registros.
       
;inhibir las interrupciones del teclado.
       IN  AL,021H        ;Leer IMR del controlador de interrupciones.
       OR  AL,02H
       OUT 21H,AL         ;Ponre a 1 el 2 bit de IMR.

ENCU:  MOV  AL,0AH
       OUT  20H,AL        ;seleccin del IRR en el registro de control.
       IN   AL,20H        ;AL:=IRR , leyendo el registro de control.
       TEST AL,02H        ;AL(1)=1?.
       JZ   ENCU
       CALL LEECAR_E      ;Devuelve en AL el cdigo de ratreo.
       CMP  AL,46         ;Caso de ser el cdigo 46 'C' => terminamos.
       JNZ  ENCU
       
       IN   AL,21H        ;Acceder al IMR.
       AND  AL,11111101B
       OUT  21H,AL        ;Habilitar la interrupciones del teclado.

       POP AX             ;Restaurar registros.
       POP BP             ;Restaurar enlace dinmico.
       RET 
ENCU_TEC2 ENDP       

; Rutina que saca un mensaje cada vez que sale la pelota por la parte
; inferior de la pantalla y an quedan vidas.
MENSAJ_CONTI PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;Guardar registros.

       MOV  DI,9
       MOV  SI,13
       MOV  BX,0F1H       ;BX:=atributo.
COMP1: MOV  AL,DS:MENSA_CONTINUAR[SI-13]
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI
       CMP  SI,36
       JNZ  COMP1

       POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
MENSAJ_CONTI ENDP

; Rutina que actualiza el nmero de vidas y lo escribe en pantalla.
ACTUALIZAR_VIDAS PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX            ;Guardar registros.
       
       MOV  AL,NUM_VIDAS
       DEC  AL
       MOV  NUM_VIDAS,AL  ;NUM_VIDAS:=NUM_VIDAS-1.
       MOV  AX,0AH           
       PUSH AX            ;Empilar el atributo.
       MOV  AL,NUM_VIDAS  
       ADD  AL,48
       PUSH AX            ;Empilar el caracter.
       MOV  AX,33
       PUSH AX            ;Empilar la columna.
       MOV  AX,23
       PUSH AX            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       
       POP  AX             ;Restaurar registros.
       POP  BP             ;Restaurar emlace dinmico.
       RET       
ACTUALIZAR_VIDAS ENDP

; Rutina que borra el mensaje de continuacin del juego y la anterior
; pelota.
REANUDAR_PANTALLA PROC NEAR
       PUSH BP
       MOV  BP,SP         ;Enlace dinmico.
       PUSH AX
       PUSH BX
       PUSH SI
       PUSH DI            ;Guardar registros.
; Con esto se borra el mensaje de continuar
       MOV  DI,9              
       MOV  SI,13
       MOV  BX,07H
COMP2: MOV  AL,32
       PUSH BX            ;Empilar atributo.
       PUSH AX            ;Empilar caracter.
       PUSH SI            ;Empilar la columna.
       PUSH DI            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.
       INC  SI
       CMP  SI,36
       JNZ  COMP2
; Con esto se borra la anterior pelota.
       MOV  AX,0FH
       PUSH AX            ;Empilar. el atributo
       MOV  AL,32
       PUSH AX            ;Empilar el caracter.
       MOV  AL,COL_PELO
       PUSH AX            ;Empilar la columna.
       MOV  AL,FIL_PELO
       PUSH AX            ;Empilar la fila.
       CALL ESCR_CAR      ;Llamada a subrutina de escritura.

       POP  DI
       POP  SI
       POP  BX
       POP  AX            ;Restaurar registros.
       MOV  SP,BP         ;Restaurar enlace dinmico.
       POP  BP
       RET  
REANUDAR_PANTALLA ENDP

CODIGO  ENDS  
        END
