; Fichero: RELOJINT.ASM
; Rutina de atencin a las interrupciones de reloj .

TITLE RELOJINT

; Rutinas NEAR que utiliza RELOJINT:
; PELOTA_PALA_BUCLE, ESPERAR.

; Rutinas FAR que utiliza  RELOJINT:
EXTRN ESCR_CAR:FAR    ;Rutina que escribe un carcter por pantalla.
EXTRN HORAPAN :FAR    ;Rutina que actualiza por pantalla el tiempo que
                      ;transcurido desde el comienzo del juego.

; Variables globales que utiliza RELOJINT:
EXTRN MINUT2:BYTE   ;Variables que contienen
EXTRN MINUT1:BYTE   ;el tiempo transcurrido
EXTRN SEGUN2:BYTE   ;desde el comienzo
EXTRN SEGUN1:BYTE   ;del juego.

EXTRN TIEMPO:BYTE      ;Nmero de interrupcin (1..18).
EXTRN TIEMPO_PASA:BYTE ;Si es un 1 transcurre el marcador del tiempo,
                       ;y si es un 0 el marcador del tiempo se para.   

EXTRN CUATRO:BYTE ;Cada cuatro interrupciones de reloj dibuja la pelota.
EXTRN TRES  :BYTE ;Cada tres interrupciones de reloj dibuja la pelota.
EXTRN FIL_PELO:BYTE  ;Variables que contienen la posicin (i,j) de
EXTRN COL_PELO:BYTE  ;la pelota.
EXTRN CAR_PELO:BYTE  ;Variable que representa a la pelota mientras se
                     ;est en modo pausa.
EXTRN VELOCIDAD_PEL:BYTE  ;Indica cada cuntas interrupcines de reloj
                          ;se dibuja la pelota en pantalla.

EXTRN SENTIDO:WORD        ;Sentido en el eje X de la raqueta (-1,1).
EXTRN POSI_PALA:BYTE      ;Contiene la actual posicin de la pelota.
EXTRN ANT_POSI_PALA:BYTE  ;Contiene la anterior posicin de la raqueta.

EXTRN DIRPAN:WORD         ;Contiene el modo video del monitor.    

EXTRN EJEC_BUCLE:BYTE     ;Sirve para ejecutar en cada interrupcin
                          ;del reloj el bucle del programa principal.
                      
CODIGO SEGMENT PARA PUBLIC 'CODIGO'
       ASSUME CS:CODIGO

PUBLIC RELOJINT
RELOJINT PROC FAR

       PUSH ES            ;Es necesario salvar DS y ES porque la
       PUSH AX            ;rutina de atencin al reloj del DOS modifica
       PUSH BX            ;estos registros, y esto se est ejecutando
       PUSH DX            ;sin que dicha rutina haya terminado.
       PUSH DS

; Con esto ponemos nuestros SEG. DATOS y SEG. PANTALLA 
       MOV  AX,SEG TIEMPO
       MOV  DS,AX        
       MOV  ES,DIRPAN    

       MOV  AL,TIEMPO     ;Incremento en cada interrupcin la variable
       INC  AL            ;TIEMPO, y cuando llegue a 18 entonces habr
       MOV  TIEMPO,AL     ;pasado un segundo.
       CMP  AL,18
       JNZ  SON
       MOV  TIEMPO,00H
       
SON:   IN   AL,61H          ;para apagar
       AND   AL,11111100B   ;el sonido
       OUT  61H,AL          ;del altavoz
     
       CALL PELOTA_PALA_BUCLE ;Actualizar la velocidad de la pelota, el
                              ;sentido de la raqueta y el bucle del
                              ;Programa principal.      
       CMP  TIEMPO_PASA,1     ;Si TIEMPO_PASA=1 entonces puedo seguir
       JZ   PASAR             ;contando el tiempo.
       
       CALL ESPERAR           ;Sino Rutina de espera.
       JMP  SALTO
       
PASAR: CMP  TIEMPO,0
       JNZ  SALTO
; Han pasado 18 interrupciones, es decir, ha pasado un segundo.
       MOV  TIEMPO,00H
       MOV  AL,SEGUN1         ;Incrementamos SEGUN1.
       INC  AL
       CMP  AL,0AH
       JZ   OTRO
; SEGUN1 es un dgito entre 0..9
       MOV  SEGUN1,AL
       MOV  AH,SEGUN2
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       MOV  AH,MINUT2
       MOV  AL,MINUT1
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       CALL HORAPAN           ;Escribir el nuevo tiempo.
SALTO: JMP  EOI               ;Para que llegue hasta el EOI.

OTRO:  MOV  AL,00H
       MOV  SEGUN1,AL
       MOV  AH,SEGUN2         ;Incrementar SEGUN2.
       INC  AH
       CMP  AH,06H
       JZ   MIN_UNO
; SEGUN2 es un dgito entre 0..5
       MOV  SEGUN2,AH
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       MOV  AL,MINUT1
       MOV  AH,MINUT2
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       CALL HORAPAN           ;Escribir el nuevo tiempo.
       JMP  EOI

MIN_UNO:MOV  AX,0
       MOV  SEGUN1,AL         ;SEGUN1 y SEGUN2 debern ser cero.
       MOV  SEGUN2,AH
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       MOV  AL,MINUT1         ;Incrementar MINUT1.
       INC  AL
       CMP  AL,0AH
       JZ   MIN_DOS
; MINUT1 es un dgito entre 0..9
       MOV  MINUT1,AL
       MOV  AH,MINUT2
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       CALL HORAPAN          ;Escribir el nuevo tiempo.
       JMP  EOI

MIN_DOS:MOV  AL,00H
       MOV  MINUT1,AL
       MOV  AH,MINUT2         ;Incrementar MINUT2.
       INC  AH
       MOV  MINUT2,AH
       OR   AL,30H
       OR   AH,30H
       PUSH AX
       CALL HORAPAN           ;Escribir el nuevo tiempo.

EOI:  ; MOV  AL,20H           ;En la rutina de atencin al reloj no es
      ; OUT  20H,AL           ;necesario ponerlo
      
       POP  DS
       POP  DX
       POP  BX
       POP  AX
       POP  ES                ;Restaurar registros y segmentos.
       IRET                   ;Retorno de rutina de servicio.

RELOJINT ENDP

; Subrutina que actualiza la velocidad de la pelota, el sentido de la
; raqueta y el bucle del Programa principal. 
PELOTA_PALA_BUCLE PROC NEAR
       PUSH BP
       MOV  BP,SP             ;Enlace dinmico.
       PUSH AX                ;Salvar registros.
       
       CMP  VELOCIDAD_PEL,4
       JL   VELOC_3_2_1
       
; En cada interrupcin del reloj cambio la posicin de la pelota.       
VELOC_4:JMP ACTUALIZAR_SENTIDO_PALA

VELOC_3_2_1:
       CMP  VELOCIDAD_PEL,3
       JL   VELOC_2_1
       
; Cada dos interrupciones del reloj cambio la pelota de posicin.
VELOC_3:MOV AL,TIEMPO                
       AND  AL,00000001B
       CMP  AL,1
       JNZ  ACABAR1
       JMP  ACTUALIZAR_SENTIDO_PALA

VELOC_2_1:
       CMP  VELOCIDAD_PEL,2
       JL   VELOC_1
       
; Cada tres interrupciones del reloj cambio la pelota de posicin.
VELOC_2:XOR AX,AX
       MOV  AL,TIEMPO 
       DIV  TRES
       CMP  AH,0
       JNZ  ACABAR1
       JMP  ACTUALIZAR_SENTIDO_PALA
       
; Cada cuatro interrupciones del reloj cambio la pelota de posicin.       
VELOC_1:XOR AX,AX
       MOV  AL,TIEMPO
       DIV  CUATRO   
       CMP  AH,0
       JNZ  ACABAR1       
 
ACTUALIZAR_SENTIDO_PALA:
       MOV  AL,POSI_PALA
       CMP  AL,ANT_POSI_PALA
       JNZ  SINO              ;Si lapelota mantiene el mismo sentido
       MOV  SENTIDO,0         ;entonces est en reposo.
       JMP  CONTI
       
SINO:  CMP  AL,ANT_POSI_PALA
       JG   SINO_
       MOV  SENTIDO,1         ;Se mueve a la izquierda (1).
       JMP  CONTI
       
SINO_: MOV  SENTIDO,2         ;Se mueve a la derecha (2).
CONTI: MOV  ANT_POSI_PALA,AL
       MOV  EJEC_BUCLE,1

ACABAR1:POP  AX               ;Restaurar registros.
       MOV  SP,BP             ;Restaurar enlace dinmico.
       POP  BP
       RET  
PELOTA_PALA_BUCLE ENDP

; Subrutina que mientras se permanece en modo pausa mantiene la pelota
; en la misma posicin, pero con otro caracter.
ESPERAR PROC NEAR
       PUSH BP
       MOV  BP,SP             ;Enlace dinmico.
       PUSH AX                ;Salvar registros.

       MOV  AX,0FH
       PUSH AX                ;Empilar el atributo.

       CMP  CAR_PELO,196
       JNZ  SINO1
       MOV  AL,92
       MOV  CAR_PELO,92       ;CAR_PELO:='\'.
       JMP  CARAC
       
SINO1: CMP  CAR_PELO,92
       JNZ  SINO2
       MOV  AL,124
       MOV  CAR_PELO,124      ;CAR_PELO:='|'.
       JMP  CARAC

SINO2: CMP  CAR_PELO,124
       JNZ  SINO3
       MOV  AL,47
       MOV  CAR_PELO,47       ;CAR_PELO:='/'.
       JMP  CARAC
       

SINO3: MOV  AL,196
       MOV  CAR_PELO,196      ;CAR_PELO:=''.
CARAC: PUSH AX

       MOV  AL,COL_PELO
       PUSH AX                ;Empilar la columna.
       MOV  AL,FIL_PELO
       PUSH AX                ;Empilar la fila.
       CALL ESCR_CAR          ;Llamada a subrutina de escritura.
       
       POP  AX                ;Restaurar registros.
       MOV  SP,BP             ;Restaurar enlace dinmico.
       POP  BP
       RET  
ESPERAR ENDP   

CODIGO   ENDS
         END
