 TITLE Teclado por ENCUESTA

 PILA SEGMENT PARA STACK 'STACK'
      DB 64 DUP ('      ')
 PILA ENDS

 LONMEM EQU OFFSET NOMBRE - OFFSET MENSAJE   ; calcula longitud mensaje
 LONGI  EQU 8
 FILA   EQU 2

 DATOS SEGMENT PARA PUBLIC 'DATA'
      DIRPAN   DW ?
      TABLA    DB 0,27,'1234567890?'
               DB 8,9,'QWERTYUIOP[]',13,'*'
               DB 'ASDFGHJKL$;$','*'
               DB '<ZXCVBNM,.-','*'
               DB ' *'
               DB ' ',13 DUP ('*')
               DB '+98-456+1230,'
       MENSAJE DB 'INTRODUCE TU NOMBRE: '
       NOMBRE  DB LONGI DUP (' ')
 DATOS ENDS


 CODIGO SEGMENT PARA PUBLIC 'CODE'
     ASSUME CS:CODIGO, SS:PILA, DS:DATOS

; PRINCIPAL 

  PRINCIPAL PROC FAR

           push DS
           sub  AX,AX
           push AX

           mov  AX,DATOS      ; actualizacin de DS
           mov  DS,AX

           call DIR_PAN
           mov  ES,DIRPAN     ; Detecta @pantalla modo texto 80c

           call  BORRAPAN
           
           lea  AX, MENSAJE   ; @comienzo
           push AX
           lea  AX, NOMBRE    ; @final
           push AX
           mov  AX, 0         ; columna
           push AX
           mov  AX, FILA      ; fila
           push AX
           mov  AX, 07h       ; attr
           push AX
           call WRITEFR       ; escribe mensaje

           call INHIBIR       ; inhibir int teclado

           lea  AX, TABLA     ; @tabla traduccin ScanCode -> ASCII
           push AX
           lea  AX, NOMBRE    ; @cadena a almacenar
           push AX
           mov  AX, LONGI     ; n caracteres a leer
           push AX
           call ENCUESTA      ; leer nombre de teclado (-> ASCII)

           call DESINHIBIR    ; desinhibir int teclado

           lea  AX, NOMBRE    ; @comienzo
           push AX
           add  AX, LONGI
           push AX
           mov  AX, 0         ; columna
           push AX
           mov  AX, FILA+1    ; fila
           push AX
           mov  AX, 07h       ; attr
           push AX
           call WRITEFR      ; escribe nombre

           ret

   PRINCIPAL ENDP


; WRITEALL 
;
;   Rutina para escribir un mensaje directamente en la memora de video.
;
; Parmetros:
;     @ comienzo del string a escribir
;     @ final del string
;     columna
;     fila
;     atributo

   WRITEFR PROC NEAR

          push  BP
          mov   BP, SP
          push  AX
          push  BX
          push  CX
          mov   AX, 10[BP]          ;AX < @final string
          mov   BX, 12[BP]          ;BX < @comienzo string
   BUCLE: cmp   BX, AX
          je    FINSTR
          mov   CL, [BX]            ;CL < char
          mov   CH, 4[BP]           ;CH < attr
          push  CX
          mov   CX, 8[BP]           ;CX < col
          push  CX
          mov   CX, 6[BP]           ;CX < fila
          push  CX
          call  WRITECHAR
          inc   BX                  ;siguiente caracter
          inc   WORD PTR 8[BP]      ;siguiente columna
          cmp   word ptr 8[BP], 79
          jge   INCY
          jmp   BUCLE
    INCY: inc   word ptr 6[BP]      ;siguiente fila
          jmp   BUCLE
  FINSTR: pop   CX
          pop   BX
          pop   AX
          mov   SP, BP
          pop   BP
          ret   10

   WRITEFR ENDP

; WRITECHAR 
;
;     Rutina para escribir un carcter directamente a memora de video.
;
; Parmetros:
;     atributo | carcter (WORD)
;     columna
;     fila

   WRITECHAR PROC NEAR

          push BP
          mov  BP, SP
          push AX
          push BX
          push CX
          push DX
          mov  AX, 4[BP]          ;AX < fila
          mov  CX, 80
          mul  CX                 ;AX <    fila * 80
          add  AX, 6[BP]          ;AX <   (fila * 80) + col
          shl  AX, 1              ;AX < 2*(fila * 80) + col
          mov  BX, AX             ;BX < @pantalla
          mov  AX, 8[BP]          ;AX < attr | char
          mov  ES:[BX], AX        ;write attr | char
          pop  DX
          pop  CX
          pop  BX
          pop  AX
          mov  SP,BP
          pop  BP
          ret  6

   WRITECHAR ENDP

;
   DIR_PAN proc  NEAR

           push  AX
           push  ES
           xor   AX, AX
           mov   ES, AX
           mov   AL, ES:[449h]
           cmp   AL, 7
           je    BCERO
           cmp   AL, 2
           je    BOCHO
           cmp   AL, 3
           je    BOCHO
           jmp   ERROR

   BCERO:  mov   DIRPAN, 0B000h
           jmp   FINAL
   BOCHO:  mov   DIRPAN, 0B800h
           jmp   FINAL
   ERROR:  mov   DIRPAN, 0h

   FINAL:  pop   ES
           pop   AX
           ret

   DIR_PAN endp
;
  BORRAPAN PROC NEAR

          push AX
          push BX
          mov  AL, ' '
          mov  AH, 07h
          mov  BX, 0

  PAN:    cmp  BX, 25*80*2
          jz   FINAL2
          mov  ES:[BX], AX
          add  BX, 2
          jmp  PAN

  FINAL2: pop  BX
          pop  AX

          ret

  BORRAPAN endp

; INHIBIR 
;
;     Deshabilita las interrupciones de teclado

  INHIBIR PROC NEAR

        push AX
        in   AL,  21h  ; lee IMR
        or   AL,  2    ; desactiva int teclado
        out  21h, AL   ;    "       "     "
        pop  AX
        ret

  INHIBIR ENDP

; DESINHIBIR 
;
;     Habilita las interrupciones de teclado

  DESINHIBIR PROC NEAR

        push AX
        in   AL,  21h   ; lee IMR
        xor  AL,  2     ; activa INT teclado
        out  21h, AL    ;   "     "     "
        pop  AX
        ret

  DESINHIBIR ENDP

; ENCUESTA 
;
; Lee teclado por encuesta el n de caracteres que se indique guardandolos
; en una variable
;
;     Parmetros:
;          @ Tabla de traduccin
;          @ variable donde guardar los caracteres leidos
;          n de caracteres que se quiere leer
;

 ENCUESTA PROC NEAR

           push BP
           mov  BP, SP
           push AX
           push BX

 ESPERA:   mov  AL,  0Ah       ;seleccionar IRR
           out  20h, AL
           in   AL,  20h       ;leer IRR > AL
           and  AL,  02h       ;comprobar pulsacin
           jz   ESPERA         ;sino...
           in   AL,  60h       ;leer SCANCODE tecla
           mov  BL,  AL
           and  BL,  80h       ;comprobar MAKE
           jnz  ESPERA         ;sino...
           mov  BX, 8[BP]      ;BX < @tabla traduccin
           xlat                ;AL < codigo ASCII tabla
           mov  BX, 6[BP]      ;BX < @cadena de relleno
           mov  [BX], AL       ;escribir caracter ledo
 FINTEC:   in   AL, 61h        ;STROBE
           or   AL, 80h
           out  61h, AL
           and  AL, 7Fh
           out  61h, AL        ;fin STROBE
           dec  word ptr 4[BP] ;siguiente caracter
           jz   TERMINAR       ;si es el ltimo no leer mas teclas
           inc  word ptr 6[BP]
           jmp  ESPERA         ;seguir leyendo
 TERMINAR: pop  BX
           pop  AX
           mov  SP, BP
           pop  BP
           ret  6

 ENCUESTA ENDP

;

 CODIGO ENDS

     END PRINCIPAL
