; ----------------------------------------------------------------------------
; Este programa  en  ensamblador  escribe por pantalla una frase introducida
; en la variable FRASE. La posicion en pantalla donse se escribira esa frase 
; es la que viene indicada por la variable LINEA y por la variable COLUMNA.
; El atributo usado es el que se indica en la variable ATRIBUTO.
;
; Autor: Alvaro Canteiro. Fecha: 8 de Noviembre de 1996.
; ----------------------------------------------------------------------------

TITLE PANTALLA (PANTALLA.ASM)
PILA SEGMENT PARA STACK 'SATCK'
     DB 64 DUP ('PILA')
PILA ENDS

DATOS SEGMENT PARA PUBLIC 'DATA'
  DIRPAN    DW ?                                   ; direccion de pantalla   
  FRASE     DB 'CUANDO EMPEZARAN LAS VACACIONES?' ; frase a escribir
  LINEA     DW 20                                  ; N linea donde escribir
  COLUMNA   DW 23                                  ; N columna donde escribir
DATOS ENDS

CODIGO SEGMENT PARA PUBLIC 'CODE'
       ASSUME CS:CODIGO, DS:DATOS, SS:PILA

PRINCIPAL PROC FAR

          PUSH DS              ; direccion de retorno del DOS
          SUB  AX,AX
          PUSH AX
      
          MOV  AX,DATOS        ; actualizacion de DS
          MOV  DS,AX
      
          CALL DIR_PAN         ; subrutina que devuelve direccion de pantalla
          MOV  ES,DIRPAN       ; mueve a ES el parametro devuelto por DIRPAN

          CMP  DIRPAN,0H       ; finaliza el programa si la variable
          JE   FIN             ; DIRPAN indica error

          CALL BORRA_PAN       ; subrutina que limpia la pantalla
          
          LEA  CX,LINEA        ; deja en CX la direccin de la variable LINEA
          LEA  DX,FRASE        ; deja en DX la direccin de comienzo de FRASE
          SUB  CX,DX           ; calcula el tamao de la variable FRASE

          MOV  DI,DX           ; mueve DX a DI para controlar desplazamiento
          XOR  BX,BX           ; BX <- 0 - control de n de caracteres escrito
          XOR  DX,DX           ; inicializa DX a cero

BUCLE:    MOV  AL,[DI]+BX      ; coloca en AL el caracter a escribir
          INC  DL              ; incrementa DL
          CMP  DL,8            ; compara DL con 8
          JNE  SEGUIR          ; si no es salta a seguir
          MOV  DL,1            ; si es igual a 8 lo baja hasta 1
SEGUIR:   MOV  AH,DL           ; coloca en AH el atributo del caracter
          PUSH AX              ; empila AX

          MOV  AX,COLUMNA      ; le va sumando 1 al parametro columna
          ADD  AX,BX           ; para que vaya escribiendo en pantalla
          PUSH AX              ; empila el parametro columna 

          MOV  AX,LINEA        ; empila el 
          PUSH AX              ; parametro linea

          CALL ESCR_CAR        ; llama a subrutina que escribe un caracter

          POP  AX              ; desempila
          POP  AX              ;   los
          POP  AX              ; parametros

          INC  BX              ; suma 1 a BX para ir al siguiente caracter
          CMP  BX,CX           ; compara n caracteres escritos/a escribir 
         
          JL BUCLE             ; va a bucle mientras es menor

FIN:      RET

PRINCIPAL ENDP


ESCR_CAR PROC NEAR            ; rutina que escribe un caracter por pantalla

         PUSH BP              ; empila direccion de retorno de subrutina
         MOV  BP,SP           ; enlace dinamico  
 
         PUSH AX              ; empila registros
         PUSH BX              ; que van a ser 
         PUSH CX              ; usados en la 
         PUSH DX              ; subrutina

         MOV  AX,4[BP]        ; linea
         MOV  BX,6[BP]        ; columna
         MOV  CX,8[BP]        ; atributo/caracter

         MOV  DX,80           ; mueve 80 a DX
         MUL  DX              ; ax := ax * dx

         ADD  AX,BX           ; ax := linea*80 + columna
         ADD  AX,AX           ; ax := (linea*80 + columna) * 2
         MOV  BX,AX           ; pasa resultado anterior a bx
         MOV  ES:[BX],CL      ; pone el caracter de CL en @(dirpan + BX)
         MOV  ES:[BX+1],CH    ; pone el atributo de CH en @(dirpan + BX) + 1

         POP  DX              ; desempila
         POP  CX              ;    los
         POP  BX              ; registros
         POP  AX              ;  usados

         POP  BP              ; desempila direccion de retorno

         RET

ESCR_CAR ENDP


DIR_PAN PROC NEAR             ; rutina que calcula la @comienzo de pantalla

         PUSH AX              ; empila registros que van
         PUSH ES              ; a ser usados

         XOR  AX,AX           ; inicializa AX a cero
         MOV  ES,AX           ; inicializa ES a cero
         MOV  AX,ES:[449H]    ; inicializa AL con direccion del modo de video

         CMP  AL,7            ; si es 7 salta a modo monocromo
         JE   MONO 

         CMP  AL,2            ; si es 2 salta a modo monocromo
         JE   MONO 

         CMP  AL,3            ; si es 3 salta a modo cga
         JE   CGA   

         JMP  ERROR           ; salta a error si ninguna de las anteriores

MONO:    MOV  DIRPAN,0B000H   ; se inicializa variable DIRPAN a modo monocromo
         JMP  FINAL  

CGA:     MOV  DIRPAN,0B800H   ; se inicializa variable DIRPAN a modo cga
         JMP  FINAL

ERROR:   MOV  DIRPAN,0H       ; se inicializa variable DIRPAN a modo error

FINAL:   POP  ES              ; desempila registros usados
         POP  AX

         RET

DIR_PAN  ENDP 


BORRA_PAN PROC NEAR           ; rutina que borra los caracteres de pantalla

         PUSH BP              ; empila direccin de retorno de subrutina
         MOV  BP,SP           ; enlace dinmico

         PUSH AX              ; empila registros
         PUSH BX              ; que van a ser usados

         MOV  AL,' '          ; mueve a AL el caracter de borrado
         MOV  AH,07H          ; mueve a AH el atributo de borrado 

         XOR  BX,BX           ; inicializa BX a cero

LIMPIA:  MOV ES:[BX],AL       ; pone el caracter de AL en @(dirpan)
         MOV ES:[BX+1],AH     ; pone el atributo de AH en @(dirpan + 1)
         ADD BX,2             ; incrementa BX en 2
         CMP BX,25*80*2       ; compara nmero caracteres escritos/a escribir
         JNE LIMPIA           ; salta a bucle2 mientras no sean iguales
         
         POP  BX              ; desempila los 
         POP  AX              ; registros usados

         POP  BP              ; desempila direccin de retorno
         RET

BORRA_PAN ENDP


CODIGO   ENDS

         END PRINCIPAL

