; ----------------------------------------------------------------------------
; Este programa  en  ensamblador  escribe por pantalla una frase introducida
; en la variable MENSAJE. Luego lee de teclado, por encuesta, un nmero de   
; teclas igual al indicado en la variable LONGI, escribiendo por pantalla, 
; posteriormente, lo que ha sido tecleado.
;
; Autor: Alvaro Canteiro. Fecha: 8 de Noviembre de 1996.    
; ----------------------------------------------------------------------------

TITLE TECLADO_ENCUESTA(TECENCU.TXT)

PILA SEGMENT PARA STACK 'STACK'
     DB 64 DUP ('PILA  ')
PILA ENDS

LONMEN   EQU OFFSET NOMBRE - OFFSET MENSAJE ; calcula longitud del mensaje
LONGI    EQU 10                             ; n caracteres a leer
LINEA    EQU 12                             ; posicin de linea
COLUMNA  EQU 25                             ; posicin de columna
ATRIBUTO EQU 07H                            ; atributo de cada caracter


DATOS SEGMENT PARA PUBLIC 'DATA'

DIRPAN  DW ?                                ; direccin de pantalla

TABLA   DB 27,'1234567890-='                ; tabla de traduccin
        DB 8,9,'QWERTYUIOP[]',12,'*'
        DB 'ASDFGHJKL$;$','*'
        DB '<ZXCVBNM,.-','*'
        DB ' *'
        DB ' ',13 DUP ('*')
        DB '+98-456+1230,'

MENSAJE DB 'INTRODUCE TU NOMBRE: '          ; mensaje a escribir 
NOMBRE  DB LONGI DUP (' ')                  ; caracteres leidos

DATOS ENDS


CODIGO SEGMENT PARA PUBLIC 'CODE'
      ASSUME CS:CODIGO, DS:DATOS, SS:PILA

PRINCIPAL PROC FAR

        PUSH DS              ; direccin de retorno del DOS
        SUB  AX,AX 
        PUSH AX

        MOV  AX,DATOS        ; actualizacin del DS
        MOV  DS,AX

        CALL DIRPANT         ; subrutina que devuelve direccin de pantalla
        MOV  ES,DIRPAN       ; mueve a ES el parmtero devuelto por DIRPANT

        CMP  DIRPAN,0H       ; finaliza el programa si la variable
        JE   FIN             ; DIRPAN indica error

        CALL BORRAPAN        ; borra la pantalla
        CALL ESCRIMEN        ; escribe el contenido de la variable mensaje
        CALL INHIBIR         ; deshabilita interrupciones de teclado
        CALL LEER            ; lee caracteres por teclado
        CALL DESINHIBIR      ; habilita interrupciones de teclado
        CALL ESCRINOM        ; escribe los caracteres leidos de teclado

FIN:    RET

PRINCIPAL ENDP


DIRPANT PROC NEAR            ; rutina que calcula la @comienzo de pantalla

        PUSH AX              ; empila registros que van 
        PUSH ES              ; a ser usados
        
        XOR  AX,AX           ; Inicializa AX a cero
        MOV  ES,AX           ; Inicializa ES a cero
        MOV  AL,ES:[449H]    ; Inicializa AL con direccin de modo de video

        CMP  AL,7            ; si es 7 salta a monocromo
        JE   MONO 

        CMP  AL,2            ; si es 2 salta a monocromo 
        JE   MONO
    
        CMP  AL,3            ; si es 3 salta a modo CGA
        JE   CGA    

        JMP  ERROR           ; salta a error si ninguna de las anteriores

MONO:   MOV  DIRPAN,0B000H   ; se inicializa variable DIRPAN a modo monocromo
        JMP  FINAL1

CGA:    MOV  DIRPAN,0B800H   ; se inicializa variable DIRPAN a modo cga
        JMP  FINAL1

ERROR:  MOV  DIRPAN,0H       ; se inicializa variable DIRPAN a modo error

FINAL1: POP  ES              ; desempila registros usados
        POP  AX

        RET

DIRPANT ENDP


BORRAPAN PROC NEAR           ; rutina que borra los caracteres de pantalla

        PUSH AX              ; empila registros 
        PUSH BX              ; que van a ser usados

        MOV  AL,' '          ; mueve a AL el caracter de borrado
        MOV  AH,07H          ; mueve a AH el atributo de borrado  

        MOV  BX,0            ; inicializa BX a cero

PAN:    CMP  BX,25*80*2      ; compara (nmero car.escritos)/(a escribir)
        JZ   FINAL2          ; salta a FINAL 2 si es TRUE
        MOV  ES:[BX],AX      ; pone el caracter/atributo en @(dirpan)
        ADD  BX,2            ; suma a BX 2
        JMP  PAN             ; salta a PAN

FINAL2: POP  BX              ; desempila los
        POP  AX              ; registros usados

        RET

BORRAPAN ENDP


ESCRIMEN PROC NEAR            ; rutina que escribe contenido variable MENSAJE

        PUSH AX               ; empila los
        PUSH BX               ; registros
        PUSH CX               ; que van a 
        PUSH DX               ; ser usados

        LEA  DX,MENSAJE       ; deja en DX la direccin de la variable MENSAJE

        MOV  DI,DX            ; mueve DX a DI para controlar desplazamiento
        XOR  BX,BX            ; BX <- 0 - control de n de caracteres escrito

BUCLE:  MOV  AL,[DI]+BX       ; coloca en AL el caracter a escribir
        MOV  AH,ATRIBUTO      ; coloca en AH el atributo del caracter
        PUSH AX               ; empila AX

        MOV  AX,COLUMNA       ; le va sumando 1 al parametro columna
        ADD  AX,BX            ; para que vaya escribiendo en pantalla
        PUSH AX               ; empila el parametro columna

        MOV  AX,LINEA         ; empila el
        PUSH AX               ; parametro linea

        CALL ESCRICAR         ; llama a subrutina que escribe un caracter

        POP  AX               ; desempila
        POP  AX               ;   los
        POP  AX               ; parametros

        INC  BX               ; suma 1 a BX para ir al siguiente caracter
        CMP  BX,LONMEN        ; compara (n car escritos)/(longitud mensaje)
         
        JL BUCLE              ; va a bucle mientras es menor

        POP  DX               ; desempila
        POP  CX               ;   los
        POP  BX               ; parametros
        POP  AX               ;  usados

        RET

ESCRIMEN ENDP   


INHIBIR PROC NEAR            ; deshabilita las interrupciones de teclado

        PUSH AX              ; empila parmetro usado

        IN   AL,21H          ; lee el registro IMR
        OR   AL,00000010B    ; desactiva interrupcin de teclado
        OUT  21H,AL          ; graba el registro IMR

        POP AX               ; desempila parmtero usado

        RET

INHIBIR ENDP


LEER PROC NEAR               ; lee de teclado por encuesta LONGI caracteres

        PUSH AX              ; empila 
        PUSH BX              ; parmetros
        PUSH CX              ; que van
        PUSH DX              ; a ser
        PUSH SI              ; usados

        LEA  CX,NOMBRE       ; deja en ES la @comienzo de NOMBRE
        MOV  DI,CX           ; mueve CX a DI
        LEA  DX,TABLA        ; deja en DX la @comienzo de TABLA

        XOR  BX,BX           ; inicializa BX a cero
        
ENC:    XOR  AX,AX           ; inicializa AX a cero
        MOV  AL,0AH          ; seleccionar el registro IRR
        OUT  20H,AL           
        IN   AL,20H          ; lee IRR y lo deja en AL

        AND  AL,00000010B    ; comprueba si se ha pulsado una tecla
        CMP  AL,00000010B
        JNE  ENC             ; si no se ha pulsado vuelve a ENC

        IN   AL,60H          ; lee el SCANCODE de la tecla y lo deja en AL
        TEST AL,10000000B    ; comprueba si es MAKE
        JNE  ENC             ; vuelve a ENC si no es MAKE

TRAD:   ADD  AX,DX           ; suma scancode + @comienzo de TABLA
        DEC  AX              ; decrementa 1 el AX
        MOV  SI,AX           ; mueve AX a SI
        MOV  CX,[SI]         ; muve el contenido de la direccin de SI a CX
        MOV  [DI]+BX,CX      ; deja en @(nombre)+BX el caracter traducido
        INC  BX              ; incrementa BX

        IN   AL,61H          ; secuencia de STROBE
        OR   AL,80H          ;
        OUT  61H,AL          ; si no se utiliza solo
        AND  AL,7FH          ; se podra leer un
        OUT  61H,AL          ; caracter de teclado

        CMP  BX,LONGI        ; comprueba (car. leidos)/(car. a leer)
        JE   FINAL3          ; si son iguales salta a FINAL3
        JMP  ENC             ; si no vuelve a encuesta

FINAL3: POP SI               ; desempila
        POP DX               ; parmetros
        POP CX               ; que han 
        POP BX               ; sido  
        POP AX               ; usados

        RET        
 
LEER ENDP


DESINHIBIR PROC NEAR         ; habilita interrrupciones de teclado

        PUSH AX              ; empila parmteru usado

        IN   AL,21H          ; lee el registro IMR
        XOR  AL,00000010B    ; activa interrupcin de teclado
        OUT  21H,AL          ; graba el registro IMR

        POP  AX              ; desempila parmetro usado
 
        RET

DESINHIBIR ENDP


ESCRINOM PROC NEAR           ; rutina que escribe contenido de variable NOMBRE

        PUSH AX              ; empila los
        PUSH BX              ; registros
        PUSH CX              ; que van a 
        PUSH DX              ; ser usados

        LEA  DX,NOMBRE       ; deja en CX la direccin de la variable NOMBRE
        MOV  CX,LONGI        ; nmero de caracteres a escribir

        MOV  DI,DX           ; mueve DX a DI para controlar desplazamiento
        XOR  BX,BX           ; BX <- 0 - control de n de caracteres escrito

BUCLE2: MOV  AL,[DI]+BX      ; coloca en AL el caracter a escribir
        MOV  AH,ATRIBUTO     ; coloca en AH el atributo del caracter
        PUSH AX              ; empila AX

        MOV  AX,COLUMNA+LONMEN   ; le va sumando 1 al parametro columna
        ADD  AX,BX               ; para que vaya escribiendo en pantalla
        PUSH AX                  ; empila el parametro columna

        MOV  AX,LINEA        ; empila el
        PUSH AX              ; parametro linea

        CALL ESCRICAR        ; llama a subrutina que escribe un caracter

        POP  AX              ; desempila
        POP  AX              ;   los
        POP  AX              ; parametros

        INC  BX              ; suma 1 a BX para ir al siguiente caracter
        CMP  BX,CX           ; compara n caracteres escritos/a escribir
         
        JL BUCLE2            ; va a bucle mientras es menor

        POP  DX              ; desempila
        POP  CX              ;   los
        POP  BX              ; parametros
        POP  AX              ;  usados

        RET

ESCRINOM ENDP


ESCRICAR PROC NEAR           ; rutina que escribe un caracter por pantalla
        
        PUSH BP              ; empila direccin de retorno de subrutina
        MOV  BP,SP           ; enlace dinmico

        PUSH AX              ; empila registros
        PUSH BX              ; que van a ser 
        PUSH CX              ; usados en la 
        PUSH DX              ; subrutina

        MOV  AX,4[BP]        ; linea
        MOV  BX,6[BP]        ; columna
        MOV  CX,8[BP]        ; atributo/caracter

        MOV  DX,80           ; mueve 80 a DX
        MUL  DX              ; ax := ax * dx

        ADD  AX,BX           ; ax := linea*80 + columna
        ADD  AX,AX           ; ax := (linea*80 + columna) * 2
        MOV  BX,AX           ; pasa resultado anterior a bx
        MOV  ES:[BX],CL      ; pone el caracter de CL en @(dirpan + BX)
        MOV  ES:[BX+1],CH    ; pone el atributo de CH en @(dirpan + BX) + 1

        POP  DX              ; desempila
        POP  CX              ;    los
        POP  BX              ; registros
        POP  AX              ;  usados

        POP  BP              ; desempila direccion de retorno

        RET


ESCRICAR ENDP


CODIGO ENDS

END PRINCIPAL      
