; ----------------------------------------------------------------------------
; Este programa en ensamblador  escribe por pantalla una frase introducida en
; la  variable  MENSAJE.  Luego  lee de teclado, por interrupcin, y mientras
; tanto escribe  en la mitad superior de la pantalla. En la mitad superior de 
; la pantalla escribe y cuando se llena borra esa mitad y vuelve a empezar en
; la primera posicin. Cuando se acaba la media pantalla en la que se escribe
; el programa realiza un scroll permitiendo que se pueda seguir escribiendo.
; 
; Teclas disponibles durante la ejecucin del programa:
;
; ESC     -> Finaliza el programa y vuelve al DOS.
; Control -> Cambia el color del caracter que escribe pasatiempo.
; Alt     -> Cambia el color del texto que se teclea.
; Shift   -> Cambia el caracter que escribe la rutina de pasatiempo.
; +       -> Aumenta la velocidad de pasatiempo. (1-9)
; -       -> Disminuye la velocidad de pasatiempo. (1-9)
;
; Autor: Alvaro Canteiro. Fecha: 20 de Noviembre de 1996.    
; ----------------------------------------------------------------------------

TITLE TECLADO_POR_INTERRUPCION(TECINT.TXT)

PILA SEGMENT PARA STACK 'STACK'
     DB 64 DUP ('PILA  ')
PILA ENDS

LONMEN  EQU OFFSET TABLA - OFFSET MENSAJE   ; calcula longitud del mensaje
LONVEL  EQU OFFSET MENSAJE - OFFSET VELOC   ; calcula longitud de veloc


DATOS SEGMENT PARA PUBLIC 'DATA'

DIRPAN  DW ?                                ; direccin de pantalla
VELOC   DB 'Velocidad: '
MENSAJE DB 'INTRODUCE TU MENSAJE'           ; frase a escribir 

TABLA   DB 27,'1234567890-='                ; tabla de traduccin
        DB 8,9,'QWERTYUIOP[]',12,'*'
        DB 'ASDFGHJKL$;$','*'
        DB '<ZXCVBNM,.-','*'
        DB ' *'
        DB ' ',13 DUP ('*')
        DB '+98-456+1230,'

LINMENS DW 15                               ; linea donde empezara MENSAJE
CARAC   DB '#'                              ; caracter que escribe pasatiempo
RETARDO DW 01C70H                           ; constante de retardo
VRET    DW 5                                ; variacin de retardo
LINEPAS DW 10                               ; n lineas que escribe PASATIEMPO
COLAUX  DW 0                                ; auxiliar para columna en TecSer
LINDIV1 DW 1                                ; posicin linea divisoria N 1 
LINDIV2 DW 14                               ; posicin linea divisoria N 2
LINDIV3 DW 16                               ; posicin linea divisoria N 3
LINDIV4 DW 25                               ; posicin linea divisoria N 4
LLENARP DW 1                                ; booleano para escribir CARAC
COLRET  DW 77                               ; n de colunma de valor retardo
LINRET  DW 24                               ; n linea de valor retardo
ATRBCAR DB 00000011B                        ; atributo del caracter pasatiempo
ATRBMEN DB 00001100B                        ; atributo del mensaje
ATRBRAM DB 00001111B                        ; atributo de la raya del mensaje
ATRBRAY DB 00001110B                        ; atributo de las rayas
ATRBRET DB 00001101B                        ; atributo del nmero de retardo
ATRBTXT DB 00000010B                        ; atributo del texto que se teclea
ATRBMEV DB 00001010B                        ; atributo del mensaje velocidad
ATRBSPA DB 00000111B                        ; atributo de espacio
CARSPA  DB ' '                              ; caracter de espacio
VAL_IP  DW ?                                ; guardar el IP original
VAL_CS  DW ?                                ; guardar el CS original

DATOS ENDS


CODIGO SEGMENT PARA PUBLIC 'CODE'
      ASSUME CS:CODIGO, DS:DATOS, SS:PILA


PRINCIPAL PROC FAR           ; programa principal

        PUSH DS              ; direccin de retorno del DOS
        SUB  AX,AX
        PUSH AX

        MOV  AX,DATOS        ; actualizacin del DS
        MOV  DS,AX

        CALL DIRPANT         ; subrutina que devuelve direccin de pantalla
        MOV  ES,DIRPAN       ; mueve a ES el parmetro devuelto por DIRPANT

        CMP  DIRPAN,0H       ; finaliza el programa si la variable
        JE   FIN             ; DIRPAN indica error

        CALL BORRAPAN        ; rutina para borrar la pantalla

        PUSH LINDIV1         ; N linea a poner la linea divisoria 1
        CALL ESCRIRAYA       ; escribe la raya divisoria
        POP  AX              ; desempila parmetro

        PUSH LINDIV2         ; N linea a poner la linea divisoria 2
        CALL ESCRIRAYA       ; escribe la raya divisoria
        POP  AX              ; desempila parmetro

        PUSH LINDIV3         ; N linea a poner la linea divisoria 3
        CALL ESCRIRAYA       ; escribe la raya divisoria
        POP  AX              ; desempila parmetro

        PUSH LINDIV4         ; N linea a poner la linea divisoria 4
        CALL ESCRIRAYA       ; escribe la raya divisoria
        POP  AX              ; desempila parmetro

        CALL ESCRIMEN        ; escribe la variable MENSAJE
        CALL MODVEC          ; modifica vector de interrupcin de teclado
        CALL PASATIEMPO      ; rutina que ejecuta tarea de pasatiempo
        CALL RESVEC          ; restaura vector de interrupcin de teclado

        CALL BORRAPAN        ; rutina para borrar la pantalla

FIN:    RET

PRINCIPAL ENDP


DIRPANT PROC NEAR            ; rutina que calcula la @comienzo de pantalla

        PUSH AX              ; empila registros que van 
        PUSH ES              ; a ser usados
        
        XOR  AX,AX           ; Inicializa AX a cero
        MOV  ES,AX           ; Inicializa ES a cero
        MOV  AL,ES:[449H]    ; Inicializa AL con direccin de modo de video

        CMP  AL,7            ; si es 7 salta a monocromo
        JE   MONO 

        CMP  AL,2            ; si es 2 salta a monocromo 
        JE   MONO
    
        CMP  AL,3            ; si es 3 salta a modo CGA
        JE   CGA    

        JMP  ERROR           ; salta a error si ninguna de las anteriores

MONO:   MOV  DIRPAN,0B000H   ; se inicializa variable DIRPAN a modo monocromo
        JMP  FINAL1

CGA:    MOV  DIRPAN,0B800H   ; se inicializa variable DIRPAN a modo cga
        JMP  FINAL1

ERROR:  MOV  DIRPAN,0H       ; se inicializa variable DIRPAN a modo error

FINAL1: POP  ES              ; desempila registros usados
        POP  AX

        RET

DIRPANT ENDP        


BORRAPAN PROC NEAR           ; rutina para borrar la pantalla

        PUSH AX              ; empila registros que
        PUSH BX              ; van a ser usados
 
        MOV  AL,CARSPA       ; pone en AL el caracter de borrado
        MOV  AH,ATRBSPA      ; pone en AH el atributo de borrado

        XOR  BX,BX           ; inicializa BX a cero

PAN:    CMP  BX,25*80*2      ; compara BX con n de caracteres borrados
        JZ   FINAL2          ; si es cero va a FINAL2
        MOV  ES:[BX],AX      ; pone en ES:[BX] el caracter de borrado
        ADD  BX,2            ; incrementa BX en dos
        JMP  PAN             ; salta a pant  

FINAL2: POP  BX              ; desempila registros que
        POP  AX              ; han sido usados

        RET

BORRAPAN ENDP
        

BORRALIN PROC NEAR           ; rutina que un N determinado de lineas

        PUSH BP              ; empila direccin de retorno de la subrutina
        MOV  BP,SP           ; enlace dinmico

        PUSH AX              ; empila
        PUSH BX              ; registros
        PUSH CX              ; que van 
        PUSH DX              ; a ser 
        PUSH SI              ; usados

        MOV  AX,4[BP]        ; linea hasta la que borrar
        MOV  BX,6[BP]        ; linea desde la que borrar

        SUB  AX,BX           ; n de lineas a borrar
                        
        MOV  DX,80           ; mueve 80 a DX
        MUL  DX              ; AX = N lineas * 80
        MOV  DX,2            ; mueve 2 a DX
        MUL  DX              ; AX = N lineas * 80 * 2 
        MOV  CX,AX           ; CX = n de posiciones a borrar

        DEC  BX              ; decrementa BX en uno

        MOV  AX,BX           ; mueve BX a AX
        MOV  DX,80           ; mueve 80 a DX
        MUL  DX              ; AX = AX * 80
        MOV  DX,2            ; mueve 2 a DX
        MUL  DX              ; AX = AX * 80 * 2
        MOV  BX,AX           ; BX = posicin desde la que se empieza a borrar

        XOR  SI,SI           ; inicializa SI a cero

        MOV  AL,CARSPA       ; inicializa AX con el caracter espacio
        MOV  AH,00000111B    ; y el atributo correspondiente

PANT:   CMP  SI,CX           ; compara (nmero car.escritos)/(a escribir)
        JZ   FIN2            ; salta a FINAL2 si es TRUE
        MOV  ES:[SI+BX],AX   ; pone el caracter/atributo en @(dirpan)
        ADD  SI,2            ; suma 2 a BX
        JMP  PANT            ; salta a PAN

FIN2:   POP  SI              ; desempila
        POP  DX              ; registros
        POP  CX              ; que han
        POP  BX              ; sido 
        POP  AX              ; usados

        POP  BP              ; desempila direccin de retorno

        RET

BORRALIN ENDP


ESCRIMEN PROC NEAR           ; subrutina que escribe la variable mensaje
      
        PUSH AX              ; empila los
        PUSH BX              ; registros
        PUSH CX              ; que van 
        PUSH DX              ; a ser
        PUSH SI              ; usados
        
        MOV  AX,LINMENS      ; AX = <LINEA>
        SUB  AX,1
        MOV  DX,80 
        MUL  DX              ; AX = LINEA * 80
        MOV  DX,2
        MUL  DX              ; AX = LINEA * 80 * 2 
        
        MOV  BX,AX           ; BX = primera posicin de linea de mensaje
        ADD  AX,79*2         ; AX = ultima posicin de linea de mensaje

        PUSH AX              ; empila ultima posicin de linea de mensaje

        XOR  AX,AX           ; inicializa AX a cero

        MOV  AL,LONMEN       ; mueve a AL la longitud del mensaje
        MOV  CL,80           ; mueve a CL el nmero de columnas por pantalla
        SUB  CL,AL           ; AL = (longitud del mensaje)/(nmero columnas)
        SUB  CL,2            ; resta dos para los espacios de principio y fin
        SAR  CL,1            ; CL = N caracteres por mitad linea

        XOR  SI,SI           ; inicializa SI a cero
        XOR  DX,DX           ; inicializa DX a cero
        XOR  AX,AX           ; inicializa DX a cero

        MOV  DL,''          ; mueve a DL el caracter de raya
        MOV  DH,ATRBRAM      ; mueve a DH el atributo de la raya del mensaje
ESCRIM: MOV  ES:[BX],DX      ; mueve DX a ES:[BX]
        ADD  BX,2            ; incrementa el desplazamiento de posiciones en 2
        INC  AL              ; incrementa el N de caracteres escritos en 1
        CMP  AL,CL           ; compara (carac. escritos)/(carac. a escribir)
        JNE  ESCRIM          ; salta e ESCRIM mientras no sea igual

        MOV  DL,CARSPA       ; mueve a DL el caracter de espacio
        MOV  DH,ATRBMEN      ; mueve a DH el atributo de mensaje
        MOV  ES:[BX],DX      ; escribe un espacio en pantalla
        ADD  BX,2            ; pasa el desplazamiento a la siguiente posicin
       
ESCRI:  MOV  DL,MENSAJE[SI]  ; Mueve a DL caracter SI de la variable MENSAJE
        MOV  DH,ATRBMEN      ; Mueve a DH el atributo correspondiente
        MOV  ES:[BX],DX      ; Pone en @[BX] el caracter/atributo DX
        ADD  BX,2            ; Incrementa BX en dos
        INC  SI              ; Incrementa SI en uno
        CMP  SI,LONMEN       ; Compara SI con Longitud del Mensaje
        JL   ESCRI           ; Salta a ESCRI si es mayor

        XOR  AX,AX           ; Inicializa AX a cero

        MOV  DL,CARSPA       ; mueve a DL el caracter de espacio
        MOV  DH,ATRBMEN      ; mueve a DH el atributo de mensaje
        MOV  ES:[BX],DX      ; escribe un espacio en pantalla
        ADD  BX,2            ; pasa el desplazamiento a la siguiente posicin

        MOV  DL,''          ; pone en DL el caracter de raya
        MOV  DH,ATRBRAM      ; pone en DH el atributo de la raya de mensaje
ESCRIN: MOV  ES:[BX],DX      ; escribe una raya del mensaje en pantalla
        ADD  BX,2            ; incrementa el desplazamiento en dos
        INC  AL              ; incrementa en uno las rayas escritas
        CMP  AL,CL           ; compara (carac. escritos)/(carac. a escribir)
        JNE  ESCRIN          ; salta a ESCRIN mientras no sea igual

        POP  BX              ; desempila ultima posicin de linea de mensaje

        MOV  DL,''          ; pone en DL el caracter de raya de mensaje
        MOV  DH,ATRBRAM      ; pone en DH el atributo de mensaje
        MOV  ES:[BX],DX      ; pone una raya en ultima posicin de la linea 
                             ; de mensaje, esto se hace por si el nmero de
                             ; caracteres de la variable mensaje es impar y
                             ; falta una raya al final
        
FIN3:   POP  SI              ; desempila
        POP  DX              ; los registros
        POP  CX              ; que han 
        POP  BX              ; sido
        POP  AX              ; usados

        RET

ESCRIMEN ENDP


ESCRIRAYA PROC NEAR          ; subrutina que escribe la variable raya

        PUSH BP              ; empila direccin de retorno de la subrutina
        MOV  BP,SP           ; enlace dinmico
      
        PUSH BX              ; empila 
        PUSH SI              ; registros
        PUSH AX              ; que van
        PUSH CX              ; a ser 
        PUSH DX              ; usados
        
        MOV  AX,4[BP]        ; AX = <LINEA>
        DEC  AX              ; decremenat AX en uno para apuntar a la linea

        MOV  DX,80 
        MUL  DX              ; AX = LINEA * 80
        MOV  DX,2
        MUL  DX              ; AX = LINEA * 80 * 2 
        
        MOV  BX,AX           ; mueve a BX la posicin de LINEA
        XOR  SI,SI           ; incializa SI a cero
        XOR  DX,DX           ; inicializa DX a cero
        XOR  AX,AX           ; inicializa AX a cero

ESCRI2: MOV  DL,''          ; Mueve a DL caracter ''
        MOV  DH,ATRBRAY      ; Mueve a DH el atributo correspondiente
        MOV  ES:[BX],DX      ; Pone en @[BX] el caracter/atributo DX
        ADD  BX,2            ; Incrementa BX en dos
        INC  SI              ; Incrementa SI en uno
        CMP  SI,80           ; Compara SI con 79
        JL   ESCRI2          ; Salta a ESCRI si es mayor

        POP  DX              ; desempila
        POP  CX              ; los
        POP  AX              ; registros
        POP  SI              ; que han  
        POP  BX              ; sido usados
 
        POP  BP              ; desempila direccin de retorno

        RET

ESCRIRAYA ENDP


MODVEC PROC NEAR             ; rutina que modifica vector interrupcin teclado

        PUSH AX              ; empila los
        PUSH BX              ; registros que
        PUSH ES              ; van a ser usados

        XOR  AX,AX           ; incializa AX a cero
        MOV  ES,AX           ; mueve a ES la direccin 0000

        IN   AL,21H          ; inhibibe la interrupcin de teclado
        OR   AL,00000010B
        OUT  21H,AL

        MOV  BX,0036D        ; mueve a BX el valor 0036
        MOV  AX,ES:[BX]      ; mueve a AX el contenido de 0000:0036
        MOV  VAL_IP,AX       ; guarda AX en la variable VAL_IP

        MOV  BX,0038D        ; mueve a AX la direccin 0038
        MOV  AX,ES:[BX]      ; mueve a AX el contenido de 0000:0038
        MOV  VAL_CS,AX       ; guarda AX en la variable VAL_CS

        MOV  AX,OFFSET TECSER ; mueve a AX la direccin de IP de TECSER
        MOV  BX,0036D         ; mueve a BX el valor 0036
        MOV  ES:[BX],AX       ; mueve AX a la direccin IP de TECSER

        MOV  AX,SEG TECSER   ; mueve a AX la direccin de CS de TECSER
        MOV  BX,0038D        ; mueve a BX el valor 0038
        MOV  ES:[BX],AX      ; mueve AX a la direccin CS de TECSER

        IN   AL,21H          ; desinhibe interrupcin de teclado
        XOR  AL,00000010B
        OUT  21H,AL

        POP  ES              ; desempila
        POP  BX              ; registros
        POP  AX              ; usados

        RET

MODVEC ENDP


PASATIEMPO PROC NEAR         ; rutina para realizar tarea de pasatiempo
 
        PUSH AX              ; empila
        PUSH BX              ; registros
        PUSH CX              ; que van
        PUSH DX              ; a
        PUSH SI              ; ser
        PUSH ES              ; usados

        MOV  BX,79*4+4       ; incializa BX a la posicin inicial
        
        MOV  AX,LINEPAS      ; mueve a AX el N de lineas a escribir
        MOV  DX,80           ; mueve a DX 80
        MUL  DX              ; AX := LINEPAS * 80 
        MOV  SI,AX           ; guarda AX en SI para recuperar el valor

        MOV  LLENARP,1       ; Booleano para llenar la pantalla de CARAC

BUC1:   MOV  CL,CARAC        ; mueve a CL el caracter a escribir
        MOV  CH,ATRBCAR      ; mueve a CH el atributo del caracter       
        MOV  ES:[BX],CX      ; mueve CX a la direccin ES:[BX]
        ADD  BX,2            ; incrementa BX en 2
        CALL ESPERA          ; llama a la rutina de espera
        CALL PONVELOC        ; escribe la velocidad de ejecucin
        DEC  AX              ; decrementa AX en uno
        MOV  DX,LLENARP      ; mueve LLENARP a DX
        MUL  DX              ; AX = AX * DX
        CMP  AX,0            ; si no igual cero (no pulsado RETURN) va a BUC1
        JNE  BUC1            ; vuelve a BUC1 si no es igual a cero

        PUSH 3               ; empila linea desde la que borrar
        PUSH 14              ; empila linea hasta la que borrar
        CALL BORRALIN        ; llama a la subrutina de borrar lineas
        POP  BX              ; desempila parmetro introducido
        POP  BX              ; desempila parmetro introducido 
        MOV  BX,79*4+4       ; inicializa BX a posicin inicial
        MOV  AX,SI           ; pone en CX el valor de lineas a escribir
        CMP  LLENARP,1       ; compara LLENARP con 1
        JE   BUC1            ; va a BUC1 si true

        POP  ES              ; desempila
        POP  SI              ; registros
        POP  DX              ; que
        POP  CX              ; han
        POP  BX              ; sido
        POP  AX              ; usados

        RET

PASATIEMPO ENDP


ESPERA PROC NEAR             ; rutina de espera

        PUSH DX              ; empila registros 
        PUSH AX              ; a ser usados

        MOV  AX,RETARDO      ; mueve RETARDO a AX
        MOV  DX,VRET         ; mueve VRET a DX
        MUL  DX              ; AX = AX * DX (valor de ratardo)
       
BUC2:   DEC  AX              ; decrementa DX en 1
        JNZ  BUC2            ; salta a BUC2 si no es igual a cero

        POP  AX              ; desempila registros 
        POP  DX              ; usados

        RET

ESPERA ENDP


PONVELOC PROC NEAR           ; subrutina que escribe la velocidad de ejecucin

        PUSH AX              ; empila
        PUSH BX              ; parmetros
        PUSH CX              ; que van
        PUSH DX              ; a ser
        PUSH SI              ; usados

        MOV  AX,LINRET       ; mueve a AX el n de linea donde se pone retardo
        MOV  DX,80           ; mueve 80 a DX
        MUL  DX              ; AX = AX * 80
        MOV  DX,2            ; mueve 2 a DX
        MUL  DX              ; AX = AX * 80 * 2
        ADD  AX,65*2         ; sume a AX desplazamiento hasta carac. velocidad
        MOV  BX,AX           ; mueve AX a BX

        XOR  SI,SI           ; inicializa SI a cero

        MOV  CL,CARSPA       ; pone el caracter espacio
        MOV  CH,ATRBSPA      ; pone el atributo de espacio
        MOV  ES:[BX],CX      ; escribe el espacio en pantalla
        ADD  BX,2            ; pone el @desp pantalla a la siguiente posicin

VEL:    MOV  CL,VELOC[SI]    ; pone el caracter apuntado de VELOC en CL
        MOV  CH,ATRBMEV      ; pone el atributo de VELOC en CH
        MOV  ES:[BX],CX      ; escribe el caracter en pantalla
        ADD  BX,2            ; apunta a la siguiente posicin de pantalla
        INC  SI              ; incrementa SI en uno
        CMP  SI,LONVEL       ; compara SI con el nmero de caracteres de VELOC
        JNE  VEL             ; salta a VEL si no es igual

        MOV  CL,byte ptr VRET ; mueve a CL el N del valor de retardo
        AND  CL,00001111b    ; pone a cero la parte alta del byte CL
        OR   CL,00110000B    ; iguala caracter de rastreo con N real
        MOV  CH,ATRBRET      ; mueve a CL el atributo del N de retardo
        PUSH CX              ; empila caracter/atributo
        PUSH COLRET          ; empila la columna deseada
        PUSH LINRET          ; empila la linea deseada
        CALL ESCRICAR        ; rutina que escribe el caracter que se le pasa
        POP  CX              ; desempila
        POP  CX              ; parmetros
        POP  CX              ; introducidos

        ADD  BX,2            ; pone el @des pantalla a la siguiente posicin
        MOV  CL,CARSPA       ; pone al caracter espacio
        MOV  CH,ATRBSPA      ; pone el atributo de espacio
        MOV  ES:[BX],CX      ; escribe el espacio en pantalla

        POP  SI              ; desempila
        POP  DX              ; parmetros
        POP  CX              ; que han 
        POP  BX              ; sido
        POP  AX              ; usados

        RET

PONVELOC ENDP


RESVEC PROC NEAR             ; restaura vector de interrupcion de teclado

        PUSH AX              ; empila registros
        PUSH BX              ; que van a 
        PUSH ES              ; ser usados

        XOR  AX,AX           ; inicializa AX a cero
        MOV  ES,AX           ; mueva a ES el valor 0000

        IN   AL,21H          ; inhibe la interrupcin de teclado
        OR   AL,00000010B
        OUT  21H,AL

        MOV  AX,VAL_IP       ; mueve el valor de VAL_IP a AX
        MOV  BX,0036D        ; mueve a BX el valor 0036
        MOV  ES:[BX],AX      ; mueve AX a la direcin 0000:0036

        MOV  AX,VAL_CS       ; nueve el valor de VAL_CS a AX
        MOV  BX,0038D        ; mueve a BX el valor 0036
        MOV  ES:[BX],AX      ; mueve AX a la direccin 0000:0038

        IN   AL,21H          ; desinhibe la interrupcin de teclado 
        XOR  AL,00000010B
        OUT  21H,AL

        POP  ES              ; desempila
        POP  BX              ; registros
        POP  AX              ; usados

        RET

RESVEC ENDP


ESCRICAR PROC NEAR           ; rutina que escribe por pantalla un caracter

        PUSH BP              ; empila direccin de retorno de subrutina
        MOV  BP,SP           ; enlace dinmico

        PUSH AX              ; empila registros
        PUSH BX              ; que van a ser 
        PUSH CX              ; usados en la 
        PUSH DX              ; subrutina

        MOV  AX,4[BP]        ; linea
        MOV  BX,6[BP]        ; columna
        MOV  CX,8[BP]        ; atributo/caracter

        MOV  DX,80           ; mueve 80 a DX
        MUL  DX              ; ax := ax * dx

        ADD  AX,BX           ; ax := linea*80 + columna
        ADD  AX,AX           ; ax := (linea*80 + columna) * 2
        MOV  BX,AX           ; pasa resultado anterior a bx
        MOV  ES:[BX],CL      ; pone el caracter de CL en @(dirpan + BX)
        MOV  ES:[BX+1],CH    ; pone el atributo de CH en @(dirpan + BX) + 1

        POP  DX              ; desempila
        POP  CX              ;    los
        POP  BX              ; registros
        POP  AX              ;  usados

        POP  BP              ; desempila direccion de retorno

        RET

ESCRICAR ENDP


TECSER PROC NEAR             ; rutina de servicio para el teclado

        PUSH AX              ; empila
        PUSH BX              ; registros
        PUSH CX              ; que van
        PUSH DX              ; a ser
        PUSH SI              ; usados

        LEA  DX,TABLA        ; deja en DX la @comienzo de TABLA
        XOR  AX,AX           ; incializa AX a cero

        IN   AL,60H          ; lee el SCANCODE de la tecla y lo deja en AL
        TEST AL,10000000B    ; comprueba si es MAKE
        JNE  FINAL3          ; va a FINAL3 si no es MAKE

        PUSH AX              ; empila SCAN de la tecla
        CALL CAMBIAVAL       ; subrutina que rastrea por los posibles valores
        POP  CX              ; desempila parmetro introducido

        ADD  AX,DX           ; suma scancode + @comienzo de TABLA
        DEC  AX              ; decrementa 1 el AX
        MOV  SI,AX           ; mueve AX a SI

        MOV  CL,[SI]         ; mueve el contenido de la direccin de SI a CL
        CMP  CL,'*'          ; comprueba si el caracter es un asterisco
        JE   FINAL3          ; salta a FINAL3 en ese caso
        CMP  CL,'+'          ; comprueba si el caracter es un signo de suma
        JE   FINAL3          ; salta a FINAL3 en ese caso
        CMP  CL,'-'          ; comprueba si el caracter es un signo de resta
        JE   FINAL3          ; salta a FINAL3 en ese caso
        CMP  CL,''         ; comprueba si el caracter es el ESC
        JE   FINAL3          ; salta a FINAL3 en ese caso
        MOV  CH,ATRBTXT      ; coloca en CH el atributo a usar
        PUSH CX              ; empila CX

        MOV  BX,COLAUX       ; mueve a BX mximo caracteres se puede escribir
        CMP  BX,480          ; comprueba si se ha llegado al mximo
        JNE  EMPILA          ; si no es igual se empila el siguiente parmetro
        CALL SCROLL          ; llama a la subrutina que hace el scroll
        MOV  BX,400          ; pasa a la primera posicin de la linea
        MOV  COLAUX,BX       ; guarda BX para recuperarlo posteriormente
EMPILA: PUSH BX              ; empila el parmetro columna

        MOV  AX,LINMENS      ; mueve LINEA a AX
        ADD  AX,2            ; incrementa LINEA en 2
        PUSH AX              ; empila el parmetro LINEA
        
        CALL ESCRICAR        ; llama a la subrutina de escribir un caracter

        POP  AX              ; desempila los
        POP  AX              ; parmetros
        POP  AX              ; usados
       
        INC  COLAUX          ; incrementa el auxiliar de columna

        IN   AL,61H          ; secuencia de STROBE
        OR   AL,80H          ;
        OUT  61H,AL          ; si no se utiliza solo 
        AND  AL,7FH          ; se podra leer un
        OUT  61H,AL          ; caracter de teclado

FINAL3: MOV  AL,20H          ; secuencia  
        OUT  20H,AL          ;   EOI

        POP SI               ; desempila
        POP DX               ; parmetros
        POP CX               ; que han 
        POP BX               ; sido  
        POP AX               ; usados

        IRET
         
TECSER ENDP        


CAMBIAVAL PROC NEAR          ; rutina que rastrea el valro de las teclas

        PUSH BP              ; empila direccin de retorno de la subrutina
        MOV  BP,SP           ; enlace dinmico

        PUSH AX              ; empila registros que
        PUSH CX              ; van a ser usados

        MOV  AL,4[BP]        ; AL = codigo SCAN de la tecla

        CMP  AL,1            ; compara con SCANCODE con 1 (ESC)
        JNE  SIGO1           ; si no es igual va a SIGO1
        MOV  LLENARP,0       ; si se ha pulsado RETURN pone LLENARP a cero

SIGO1:  CMP  AL,29           ; compara con SCANCODE con 29 (control)
        JNE  SIGO2           ; sino es igual pasa a la siguiente comprobacin
        MOV  CL,ATRBCAR      ; mueve a CL el atributo de caracter
        INC  CL              ; incrementa CL en uno
        CMP  CL,00010000B    ; compara CL con ultimo atributo posible + 1
        JNE  SIGO11          ; si no es igual salta a SIGO11
        MOV  CL,00000000B    ; pone en CL el atributo 0
SIGO11: MOV  ATRBCAR,CL      ; graba en ATRBCAR el nuevo atributo

SIGO2:  CMP  AL,56           ; compara con SCANCODE con 56 (alt)
        JNE  SIGO3           ; sino es igual pasa a la siguiente comprobacin
        MOV  CL,ATRBTXT      ; mueve a CL el atributo de texto
        INC  CL              ; incrementa CL en uno
        CMP  CL,00010000B    ; compara CL con ultimo atributo posible + 1
        JNE  SIGO22          ; si no es igual salta a SIGO22
        MOV  CL,00000000B    ; pone en CL el atributo 0
SIGO22: MOV  ATRBTXT,CL      ; graba en ATRBTXT el nuevo atributo

SIGO3:  CMP  AL,78           ; compara con SCANCODE con 78 (+)
        JNE  SIGO4           ; sino es igual pasa a la siguiente comprobacin
        MOV  CX,VRET         ; mueve a CX el valor de retardo
        CMP  CX,1            ; compara CX con retardo mnimo
        JE   SIGO33          ; si es igual no decrementa
        DEC  CX              ; decrementa CX en uno
SIGO33: MOV  VRET,CX         ; graba en VRET el nuevo atributo

SIGO4:  CMP  AL,74           ; compara con SCANCODE con 74 (-)
        JNE  SIGO5           ; sino es igual pasa a la siguiente comprobacin
        MOV  CX,VRET         ; mueve a CX el valor de retardo
        CMP  CX,9            ; compara CX con retardo mximo
        JE   SIGO44          ; si es igial no incrementa
        INC  CX              ; incrementa CX en uno
SIGO44: MOV  VRET,CX         ; graba en VRET el nuevo atributo

SIGO5:  CMP  AL,42           ; compara con SCANCODE 42 (shift izquierda)
        JE   SIGO54          ; sino es igual salta a SIGO54
        CMP  AL,54           ; compara con SCANCODE 54 (shift derecha)
        JE   SIGO54          ; sino es igual salta a SIGO54
        JNE  SIGO6           ; salta a SIGO6 si no se cumple las 2 condiciones
SIGO54: MOV  CL,CARAC        ; mueve el caracter de pasatiempo a CL
        INC  CL              ; pasa al siguiente caracter ascii
        CMP  CL,''          ; compara con el ultimo caracter imprimible ascii
        JNE  SIGO55          ; sino es igual salta a SIGO55
        MOV  CL,'!'          ; coloca en CL el primer caracer imprimible ascii
SIGO55: MOV  CARAC,CL        ; mueve CL a la variable CARAC

SIGO6:  POP  CX              ; desempila registros que
        POP  AX              ; han sido usados

        POP  BP              ; desempila direccin de retorno
 
        RET 

CAMBIAVAL ENDP


SCROLL PROC NEAR             ; rutina que realiza el scroll de pantalla

        PUSH AX              ; empila
        PUSH BX              ; registros
        PUSH CX              ; que van
        PUSH DX              ; a ser
        PUSH SI              ; usados

        MOV  AX,LINMENS      ; mueve a AX el N linea donde esta MENSAJE
        ADD  AX,8            ; mueve a AX el N de linea donde acaba el texto
        MOV  DX,80           ; mueve a DX el valor 80
        MUL  DX              ; AX = AX * 80
        MOV  DX,2            ; mueve a DX el valor 2
        MUL  DX              ; AX = AX * 80 * 2
        SUB  AX,2            ; AX = (AX * 80 * 2) - 2
        MOV  CX,AX           ; CX = posicin ultimo caracter escrito

        MOV  AX,LINMENS      ; mueve a AX el N de linea donde esta MENSAJE
        ADD  AX,2            ; mueve a AX el N de linea donde empieza texto
        MOV  DX,80           ; mueve a DX el valor 80
        MUL  DX              ; AX = AX * 80
        MOV  DX,2            ; mueve a DX el valor 2
        MUL  DX              ; AX = AX * 80 * 2
        MOV  BX,AX           ; BX = posicin primer caracter escrito

        ADD  CX,2            ; suma a ultimo caracter el valor 2

BUC3:   MOV  SI,BX           ; copia la posicin del primer caracter a SI
        ADD  SI,160          ; apunta al mismo caracter de la siguiente linea
        MOV  AX,ES:[SI]      ; pone el caracter anterior en AX
        MOV  ES:[BX],AX      ; copia AX en el primer caracter 
        ADD  BX,2            ; apunta para procesar el siguiente caracter
        CMP  BX,CX           ; compara (posic. car. procesado) (ult. caracter)
        JNE  BUC3            ; mientras no sea igual salta a BUC3

        POP SI               ; desempila
        POP DX               ; registros
        POP CX               ; que han
        POP BX               ; sido
        POP AX               ; usados

        RET

SCROLL ENDP


CODIGO ENDS

END PRINCIPAL  